
#ifndef __SWITCHER_H__
#define __SWITCHER_H__

#include <glib.h>
#include <glib-object.h>
#include <libgnomenu/menubar.h>
#include <gtk/gtk.h>
#include <libgnomenu/menuitem.h>
#include <stdlib.h>
#include <string.h>
#include <libwnck/libwnck.h>

G_BEGIN_DECLS


#define TYPE_SWITCHER (switcher_get_type ())
#define SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SWITCHER, Switcher))
#define SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SWITCHER, SwitcherClass))
#define IS_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SWITCHER))
#define IS_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SWITCHER))
#define SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SWITCHER, SwitcherClass))

typedef struct _Switcher Switcher;
typedef struct _SwitcherClass SwitcherClass;
typedef struct _SwitcherPrivate SwitcherPrivate;

#define TYPE_SEARCH_BOX_MENU_ITEM (search_box_menu_item_get_type ())
#define SEARCH_BOX_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_BOX_MENU_ITEM, SearchBoxMenuItem))
#define SEARCH_BOX_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_BOX_MENU_ITEM, SearchBoxMenuItemClass))
#define IS_SEARCH_BOX_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_BOX_MENU_ITEM))
#define IS_SEARCH_BOX_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_BOX_MENU_ITEM))
#define SEARCH_BOX_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_BOX_MENU_ITEM, SearchBoxMenuItemClass))

typedef struct _SearchBoxMenuItem SearchBoxMenuItem;
typedef struct _SearchBoxMenuItemClass SearchBoxMenuItemClass;
typedef struct _SearchBoxMenuItemPrivate SearchBoxMenuItemPrivate;

struct _Switcher {
	GnomenuMenuBar parent_instance;
	SwitcherPrivate * priv;
};

struct _SwitcherClass {
	GnomenuMenuBarClass parent_class;
};

struct _SearchBoxMenuItem {
	GtkImageMenuItem parent_instance;
	SearchBoxMenuItemPrivate * priv;
};

struct _SearchBoxMenuItemClass {
	GtkImageMenuItemClass parent_class;
};


Switcher* switcher_construct (GType object_type);
Switcher* switcher_new (void);
WnckWindow* switcher_get_current_window (Switcher* self);
void switcher_set_current_window (Switcher* self, WnckWindow* value);
gint switcher_get_max_size (Switcher* self);
void switcher_set_max_size (Switcher* self, gint value);
gboolean switcher_get_show_icon (Switcher* self);
void switcher_set_show_icon (Switcher* self, gboolean value);
gboolean switcher_get_show_label (Switcher* self);
void switcher_set_show_label (Switcher* self, gboolean value);
gboolean switcher_get_show_window_list (Switcher* self);
void switcher_set_show_window_list (Switcher* self, gboolean value);
gboolean switcher_get_show_window_actions (Switcher* self);
void switcher_set_show_window_actions (Switcher* self, gboolean value);
GType switcher_get_type (void);
SearchBoxMenuItem* search_box_menu_item_construct (GType object_type);
SearchBoxMenuItem* search_box_menu_item_new (void);
GnomenuMenuItem* search_box_menu_item_find_item (SearchBoxMenuItem* self);
const char* search_box_menu_item_get_text (SearchBoxMenuItem* self);
void search_box_menu_item_set_text (SearchBoxMenuItem* self, const char* value);
GType search_box_menu_item_get_type (void);


G_END_DECLS

#endif
