
#include "template.h"




static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



char* template_replace_simple (const char* template, const char* keyword, const char* value) {
	char** _tmp3;
	gint subs_size;
	gint subs_length1;
	char** _tmp2;
	const char* _tmp1;
	const char* _tmp0;
	char** subs;
	char* _tmp4;
	g_return_val_if_fail (template != NULL, NULL);
	g_return_val_if_fail (keyword != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_tmp3 = NULL;
	_tmp2 = NULL;
	_tmp1 = NULL;
	_tmp0 = NULL;
	subs = (_tmp3 = (_tmp2 = g_new0 (char*, 2 + 1), _tmp2[0] = (_tmp0 = keyword, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), _tmp2[1] = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), _tmp2), subs_length1 = 2, subs_size = subs_length1, _tmp3);
	_tmp4 = NULL;
	return (_tmp4 = template_replace (template, subs, subs_length1), subs = (_vala_array_free (subs, subs_length1, (GDestroyNotify) g_free), NULL), _tmp4);
}


char* template_replace (const char* template, char** subs, int subs_length1) {
	const char* p;
	gunichar c;
	gint state;
	const char* keyword;
	gunichar keyword_open;
	GString* sb;
	const char* _tmp1;
	char* _tmp2;
	g_return_val_if_fail (template != NULL, NULL);
	p = template;
	c = 0U;
	state = TEMPLATE_NORMAL;
	keyword = NULL;
	keyword_open = (gunichar) 0;
	sb = g_string_new ("");
	while (0 != (c = g_utf8_get_char (p))) {
		switch (state) {
			case TEMPLATE_NORMAL:
			{
				switch (c) {
					case '@':
					case '%':
					{
						keyword_open = c;
						keyword = p;
						state = TEMPLATE_KEYWORD;
						break;
					}
					default:
					{
						g_string_append_unichar (sb, c);
						break;
					}
				}
				break;
			}
			case TEMPLATE_KEYWORD:
			{
				switch (c) {
					default:
					{
						if (c == keyword_open) {
							gboolean found;
							found = FALSE;
							{
								gint i;
								i = 0;
								for (; i < subs_length1; i = i + 2) {
									const char* st_keyword;
									const char* st_value;
									const char* pp;
									const char* qq;
									gunichar cc;
									gunichar dd;
									st_keyword = subs[i];
									st_value = subs[i + 1];
									pp = keyword;
									qq = st_keyword;
									cc = (gunichar) 0;
									dd = (gunichar) 0;
									while (TRUE) {
										gboolean _tmp0;
										_tmp0 = FALSE;
										if (0 != (cc = g_utf8_get_char (pp))) {
											_tmp0 = 0 != (dd = g_utf8_get_char (qq));
										} else {
											_tmp0 = FALSE;
										}
										if (!_tmp0) {
											break;
										}
										if (cc != dd) {
											break;
										}
										qq = g_utf8_next_char (qq);
										pp = g_utf8_next_char (pp);
									}
									if (dd == 0) {
										g_string_append (sb, st_value);
										found = TRUE;
										break;
									}
								}
							}
							if (!found) {
								g_string_append_unichar (sb, c);
								g_string_append (sb, keyword);
								g_string_append_unichar (sb, c);
							}
							state = TEMPLATE_NORMAL;
							keyword = NULL;
						}
						break;
					}
				}
				break;
			}
		}
		p = g_utf8_next_char (p);
	}
	_tmp1 = NULL;
	_tmp2 = NULL;
	return (_tmp2 = (_tmp1 = sb->str, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), (sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL)), _tmp2);
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
	g_free (array);
}




