
#ifndef __WORKSPACESELECTOR_H__
#define __WORKSPACESELECTOR_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libwnck/libwnck.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>

G_BEGIN_DECLS


#define TYPE_WORKSPACE_SELECTOR (workspace_selector_get_type ())
#define WORKSPACE_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKSPACE_SELECTOR, WorkspaceSelector))
#define WORKSPACE_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKSPACE_SELECTOR, WorkspaceSelectorClass))
#define IS_WORKSPACE_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKSPACE_SELECTOR))
#define IS_WORKSPACE_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKSPACE_SELECTOR))
#define WORKSPACE_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKSPACE_SELECTOR, WorkspaceSelectorClass))

typedef struct _WorkspaceSelector WorkspaceSelector;
typedef struct _WorkspaceSelectorClass WorkspaceSelectorClass;
typedef struct _WorkspaceSelectorPrivate WorkspaceSelectorPrivate;

#define TYPE_WORKSPACE_ITEM (workspace_item_get_type ())
#define WORKSPACE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKSPACE_ITEM, WorkspaceItem))
#define WORKSPACE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKSPACE_ITEM, WorkspaceItemClass))
#define IS_WORKSPACE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKSPACE_ITEM))
#define IS_WORKSPACE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKSPACE_ITEM))
#define WORKSPACE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKSPACE_ITEM, WorkspaceItemClass))

typedef struct _WorkspaceItem WorkspaceItem;
typedef struct _WorkspaceItemClass WorkspaceItemClass;
typedef struct _WorkspaceItemPrivate WorkspaceItemPrivate;

struct _WorkspaceSelector {
	GtkWindow parent_instance;
	WorkspaceSelectorPrivate * priv;
};

struct _WorkspaceSelectorClass {
	GtkWindowClass parent_class;
};

/* WorkspaceItem */
struct _WorkspaceItem {
	GtkEventBox parent_instance;
	WorkspaceItemPrivate * priv;
	gint viewport_x;
	gint viewport_y;
};

struct _WorkspaceItemClass {
	GtkEventBoxClass parent_class;
};


GdkPixbuf* _wnck_gdk_pixbuf_get_from_pixmap (GdkPixbuf* dest, GdkPixmap* xpixmap, gint src_x, gint src_y, gint dest_x, gint dest_y, gint width, gint height);
GdkPixbuf* gdk_pixbuf_get_from_drawable (GdkPixbuf* dest, GdkDrawable* src, GdkColormap* cmap, gint src_x, gint src_y, gint dest_x, gint dest_y, gint width, gint height);
WorkspaceSelector* workspace_selector_construct (GType object_type, WnckWindow* window);
WorkspaceSelector* workspace_selector_new (WnckWindow* window);
gint workspace_selector_get_nrows (WorkspaceSelector* self);
gint workspace_selector_get_ncols (WorkspaceSelector* self);
gint workspace_selector_get_screen_width (WorkspaceSelector* self);
gint workspace_selector_get_screen_height (WorkspaceSelector* self);
gint workspace_selector_get_workspace_width (WorkspaceSelector* self);
gint workspace_selector_get_workspace_height (WorkspaceSelector* self);
gint workspace_selector_get_current_column (WorkspaceSelector* self);
gint workspace_selector_get_current_row (WorkspaceSelector* self);
WorkspaceItem* workspace_selector_get_selected_item (WorkspaceSelector* self);
GType workspace_selector_get_type (void);
WorkspaceItem* workspace_item_construct (GType object_type);
WorkspaceItem* workspace_item_new (void);
WorkspaceItem* workspace_item_construct_with_pixbuf (GType object_type, GdkPixbuf* pixbuf);
WorkspaceItem* workspace_item_new_with_pixbuf (GdkPixbuf* pixbuf);
GtkImage* workspace_item_get_image (WorkspaceItem* self);
void workspace_item_set_image (WorkspaceItem* self, GtkImage* value);
gint workspace_item_get_margin (WorkspaceItem* self);
void workspace_item_set_margin (WorkspaceItem* self, gint value);
gboolean workspace_item_get_selected (WorkspaceItem* self);
void workspace_item_set_selected (WorkspaceItem* self, gboolean value);
gboolean workspace_item_get_current (WorkspaceItem* self);
void workspace_item_set_current (WorkspaceItem* self, gboolean value);
GType workspace_item_get_type (void);


G_END_DECLS

#endif
