
#include <gtk-modules/globalmenu/globalmenu-locator.h>




static GlobalMenuGTKLocator* global_menu_gtk_locator_new (void);
static void global_menu_gtk_locator_instance_init (GlobalMenuGTKLocator * self);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



static GlobalMenuGTKLocator* global_menu_gtk_locator_new (void) {
	GlobalMenuGTKLocator* self;
	self = g_slice_new0 (GlobalMenuGTKLocator);
	global_menu_gtk_locator_instance_init (self);
	return self;
}


GtkMenuItem* global_menu_gtk_locator_locate (GtkMenuBar* menubar, const char* path) {
	char** _tmp1;
	gint tokens_size;
	gint tokens_length1;
	char** _tmp0;
	char** tokens;
	GtkMenuShell* _tmp2;
	GtkMenuShell* shell;
	GtkMenuItem* _tmp14;
	g_return_val_if_fail (menubar != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	tokens = (_tmp1 = _tmp0 = g_strsplit_set (path, "/", -1), tokens_length1 = _vala_array_length (_tmp0), tokens_size = tokens_length1, _tmp1);
	tokens_length1 = (gint) g_strv_length (tokens);
	_tmp2 = NULL;
	shell = (_tmp2 = (GtkMenuShell*) menubar, (_tmp2 == NULL) ? NULL : g_object_ref (_tmp2));
	{
		gint i;
		/*
		weak string rev = tokens[0];
		FIXME: implement the revision */
		i = 1;
		for (; i < tokens_length1; i++) {
			const char* token;
			GtkMenuItem* item;
			GList* children;
			GtkMenuShell* _tmp12;
			GtkMenuShell* _tmp11;
			token = tokens[i];
			item = NULL;
			children = gtk_container_get_children ((GtkContainer*) shell);
			if (g_str_has_prefix (token, "W")) {
				gulong pointer;
				pointer = strtoul (g_utf8_offset_to_pointer (token, (glong) 1), NULL, 0);
				/*Widget Pointer*/
				{
					GList* child_collection;
					GList* child_it;
					child_collection = children;
					for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
						GtkWidget* child;
						child = (GtkWidget*) child_it->data;
						{
							if (((gulong) child) == pointer) {
								GtkMenuItem* _tmp5;
								GtkMenuItem* _tmp4;
								GtkWidget* _tmp3;
								_tmp5 = NULL;
								_tmp4 = NULL;
								_tmp3 = NULL;
								item = (_tmp5 = (_tmp4 = (_tmp3 = child, GTK_IS_MENU_ITEM (_tmp3) ? ((GtkMenuItem*) _tmp3) : NULL), (_tmp4 == NULL) ? NULL : g_object_ref (_tmp4)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp5);
								break;
							}
						}
					}
				}
			} else {
				gint position;
				/*assume it is an id*/
				position = atoi (token);
				{
					GList* child_collection;
					GList* child_it;
					child_collection = children;
					for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
						GtkWidget* child;
						child = (GtkWidget*) child_it->data;
						{
							if (GTK_IS_TEAROFF_MENU_ITEM (child)) {
								continue;
							}
							if (position == 0) {
								GtkMenuItem* _tmp8;
								GtkMenuItem* _tmp7;
								GtkWidget* _tmp6;
								_tmp8 = NULL;
								_tmp7 = NULL;
								_tmp6 = NULL;
								item = (_tmp8 = (_tmp7 = (_tmp6 = child, GTK_IS_MENU_ITEM (_tmp6) ? ((GtkMenuItem*) _tmp6) : NULL), (_tmp7 == NULL) ? NULL : g_object_ref (_tmp7)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp8);
								break;
							}
							position--;
						}
					}
				}
			}
			if (i == (tokens_length1 - 1)) {
				GtkMenuItem* _tmp9;
				_tmp9 = NULL;
				return (_tmp9 = item, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp9);
			}
			if (item == NULL) {
				GtkMenuItem* _tmp10;
				_tmp10 = NULL;
				return (_tmp10 = NULL, (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp10);
			}
			_tmp12 = NULL;
			_tmp11 = NULL;
			shell = (_tmp12 = (_tmp11 = (GtkMenuShell*) gtk_menu_item_get_submenu (item), (_tmp11 == NULL) ? NULL : g_object_ref (_tmp11)), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp12);
			if (shell == NULL) {
				GtkMenuItem* _tmp13;
				_tmp13 = NULL;
				return (_tmp13 = NULL, (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp13);
			}
			(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
			(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
		}
	}
	_tmp14 = NULL;
	return (_tmp14 = NULL, tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp14);
}


static void global_menu_gtk_locator_instance_init (GlobalMenuGTKLocator * self) {
}


void global_menu_gtk_locator_free (GlobalMenuGTKLocator* self) {
	g_slice_free (GlobalMenuGTKLocator, self);
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




