
#include <gtk-modules/globalmenu/globalmenu.h>
#include <dyn-patch.h>
#include <gtk-modules/globalmenu/globalmenu-serializer.h>
#include <gtk-modules/globalmenu/globalmenu-locator.h>




gulong global_menu_gtk_changed_hook_id = 0UL;
gulong global_menu_gtk_attached_hook_id = 0UL;
gulong global_menu_gtk_detached_hook_id = 0UL;
gboolean global_menu_gtk_disable_pixbuf = FALSE;
gboolean global_menu_gtk_hybrid = FALSE;
static gboolean _global_menu_gtk_changed_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self);
static gboolean _global_menu_gtk_attached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self);
static gboolean _global_menu_gtk_detached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self);
static gboolean _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event (GtkWindow* _sender, const GdkEventProperty* event, gpointer self);
static void _global_menu_gtk_window_realize_gtk_widget_realize (GtkWindow* _sender, gpointer self);




GType global_menu_gtk_flags_get_type (void) {
	static GType global_menu_gtk_flags_type_id = 0;
	if (G_UNLIKELY (global_menu_gtk_flags_type_id == 0)) {
		static const GEnumValue values[] = {{GLOBAL_MENU_GTK_FLAGS_NONE, "GLOBAL_MENU_GTK_FLAGS_NONE", "none"}, {GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF, "GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF", "disable-pixbuf"}, {GLOBAL_MENU_GTK_FLAGS_HYBRID, "GLOBAL_MENU_GTK_FLAGS_HYBRID", "hybrid"}, {0, NULL, NULL}};
		global_menu_gtk_flags_type_id = g_enum_register_static ("GlobalMenuGTKFlags", values);
	}
	return global_menu_gtk_flags_type_id;
}


static gboolean _global_menu_gtk_changed_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self) {
	return global_menu_gtk_changed_eh (ihint, param_values_length1, param_values);
}


static gboolean _global_menu_gtk_attached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self) {
	return global_menu_gtk_attached_eh (ihint, param_values_length1, param_values);
}


static gboolean _global_menu_gtk_detached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self) {
	return global_menu_gtk_detached_eh (ihint, param_values_length1, param_values);
}


void global_menu_gtk_init (GlobalMenuGTKFlags flags) {
	if ((flags & GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF) != 0) {
		global_menu_gtk_disable_pixbuf = TRUE;
	}
	if ((flags & GLOBAL_MENU_GTK_FLAGS_HYBRID) != 0) {
		global_menu_gtk_hybrid = TRUE;
	}
	global_menu_gtk_changed_hook_id = g_signal_add_emission_hook (g_signal_lookup ("dyn-patch-changed", GTK_TYPE_MENU_BAR), (GQuark) 0, _global_menu_gtk_changed_eh_gsignal_emission_hook, NULL, NULL);
	global_menu_gtk_attached_hook_id = g_signal_add_emission_hook (g_signal_lookup ("dyn-patch-attached", GTK_TYPE_MENU_BAR), (GQuark) 0, _global_menu_gtk_attached_eh_gsignal_emission_hook, NULL, NULL);
	global_menu_gtk_detached_hook_id = g_signal_add_emission_hook (g_signal_lookup ("dyn-patch-detached", GTK_TYPE_MENU_BAR), (GQuark) 0, _global_menu_gtk_detached_eh_gsignal_emission_hook, NULL, NULL);
}


void global_menu_gtk_uninit (void) {
	GList* toplevels;
	g_signal_remove_emission_hook (g_signal_lookup ("dyn-patch-changed", GTK_TYPE_MENU_BAR), global_menu_gtk_changed_hook_id);
	g_signal_remove_emission_hook (g_signal_lookup ("dyn-patch-attached", GTK_TYPE_MENU_BAR), global_menu_gtk_attached_hook_id);
	g_signal_remove_emission_hook (g_signal_lookup ("dyn-patch-detached", GTK_TYPE_MENU_BAR), global_menu_gtk_detached_hook_id);
	toplevels = gtk_window_list_toplevels ();
	{
		GList* toplevel_collection;
		GList* toplevel_it;
		toplevel_collection = toplevels;
		for (toplevel_it = toplevel_collection; toplevel_it != NULL; toplevel_it = toplevel_it->next) {
			GtkWidget* _tmp3;
			GtkWidget* toplevel;
			_tmp3 = NULL;
			toplevel = (_tmp3 = (GtkWidget*) toplevel_it->data, (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3));
			{
				GtkMenuBar* _tmp0;
				GtkMenuBar* menubar;
				GtkWidget* _tmp1;
				if (!GTK_IS_WINDOW (toplevel)) {
					(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
					continue;
				}
				_tmp0 = NULL;
				menubar = (_tmp0 = GTK_MENU_BAR (dyn_patch_get_menubar (toplevel)), (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
				if (menubar == NULL) {
					(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
					continue;
				}
				_tmp1 = NULL;
				global_menu_gtk_unbind_menubar_from_window (menubar, (_tmp1 = toplevel, GTK_IS_WINDOW (_tmp1) ? ((GtkWindow*) _tmp1) : NULL));
				gtk_widget_queue_resize ((GtkWidget*) menubar);
				if (0 != (GTK_WIDGET_FLAGS ((GtkWidget*) menubar) & GTK_REALIZED)) {
					gboolean _tmp2;
					if ((g_object_get ((GtkWidget*) menubar, "visible", &_tmp2, NULL), _tmp2)) {
						gtk_widget_unrealize ((GtkWidget*) menubar);
						gtk_widget_map ((GtkWidget*) menubar);
					}
				}
				if (0 != (GTK_WIDGET_FLAGS (toplevel) & GTK_REALIZED)) {
					gdk_window_set_menu_context (toplevel->window, NULL);
				}
				(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	(toplevels == NULL) ? NULL : (toplevels = (g_list_free (toplevels), NULL));
}


gboolean global_menu_gtk_attached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values) {
	GtkMenuBar* _tmp3;
	GValue _tmp1 = {0};
	GObject* _tmp2;
	GtkMenuBar* menubar;
	GtkWindow* _tmp6;
	GValue _tmp4 = {0};
	GObject* _tmp5;
	GtkWindow* window;
	gboolean _tmp7;
	if ((*ihint).run_type != G_SIGNAL_RUN_FIRST) {
		return TRUE;
	}
	_tmp3 = NULL;
	_tmp2 = NULL;
	menubar = (_tmp3 = (_tmp2 = g_value_get_object ((_tmp1 = param_values[0], &_tmp1)), GTK_IS_MENU_BAR (_tmp2) ? ((GtkMenuBar*) _tmp2) : NULL), (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3));
	_tmp6 = NULL;
	_tmp5 = NULL;
	window = (_tmp6 = (_tmp5 = g_value_get_object ((_tmp4 = param_values[1], &_tmp4)), GTK_IS_WINDOW (_tmp5) ? ((GtkWindow*) _tmp5) : NULL), (_tmp6 == NULL) ? NULL : g_object_ref (_tmp6));
	g_debug ("globalmenu.vala:76: attached_eh menubar %p to window %p", menubar, window);
	if (global_menu_gtk_menubar_should_be_skipped (menubar)) {
		global_menu_gtk_menubar_set_local (menubar, TRUE);
	} else {
		global_menu_gtk_menubar_set_local (menubar, FALSE);
		global_menu_gtk_bonobo_plug_widget_hack ((GtkWidget*) menubar);
	}
	global_menu_gtk_bind_menubar_to_window (menubar, window);
	return (_tmp7 = TRUE, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), (window == NULL) ? NULL : (window = (g_object_unref (window), NULL)), _tmp7);
}


gboolean global_menu_gtk_detached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values) {
	GtkMenuBar* _tmp3;
	GValue _tmp1 = {0};
	GObject* _tmp2;
	GtkMenuBar* menubar;
	GtkWindow* _tmp6;
	GValue _tmp4 = {0};
	GObject* _tmp5;
	GtkWindow* window;
	gboolean _tmp7;
	if ((*ihint).run_type != G_SIGNAL_RUN_FIRST) {
		return TRUE;
	}
	_tmp3 = NULL;
	_tmp2 = NULL;
	menubar = (_tmp3 = (_tmp2 = g_value_get_object ((_tmp1 = param_values[0], &_tmp1)), GTK_IS_MENU_BAR (_tmp2) ? ((GtkMenuBar*) _tmp2) : NULL), (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3));
	_tmp6 = NULL;
	_tmp5 = NULL;
	window = (_tmp6 = (_tmp5 = g_value_get_object ((_tmp4 = param_values[1], &_tmp4)), GTK_IS_WINDOW (_tmp5) ? ((GtkWindow*) _tmp5) : NULL), (_tmp6 == NULL) ? NULL : g_object_ref (_tmp6));
	g_debug ("globalmenu.vala:93: detached_eh menubar %p from window %p", menubar, window);
	global_menu_gtk_unbind_menubar_from_window (menubar, window);
	return (_tmp7 = TRUE, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), (window == NULL) ? NULL : (window = (g_object_unref (window), NULL)), _tmp7);
}


gboolean global_menu_gtk_changed_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values) {
	GtkMenuBar* _tmp2;
	GValue _tmp0 = {0};
	GObject* _tmp1;
	GtkMenuBar* self;
	gboolean _tmp7;
	_tmp2 = NULL;
	_tmp1 = NULL;
	self = (_tmp2 = (_tmp1 = g_value_get_object ((_tmp0 = param_values[0], &_tmp0)), GTK_IS_MENU_BAR (_tmp1) ? ((GtkMenuBar*) _tmp1) : NULL), (_tmp2 == NULL) ? NULL : g_object_ref (_tmp2));
	if (self != NULL) {
		GtkWindow* _tmp5;
		GtkWindow* toplevel;
		if (global_menu_gtk_menubar_get_local (self)) {
			gboolean _tmp3;
			return (_tmp3 = TRUE, (self == NULL) ? NULL : (self = (g_object_unref (self), NULL)), _tmp3);
		}
		if ((*ihint).run_type != G_SIGNAL_RUN_FIRST) {
			gboolean _tmp4;
			return (_tmp4 = TRUE, (self == NULL) ? NULL : (self = (g_object_unref (self), NULL)), _tmp4);
		}
		_tmp5 = NULL;
		toplevel = (_tmp5 = dyn_patch_get_window (self), (_tmp5 == NULL) ? NULL : g_object_ref (_tmp5));
		if (toplevel != NULL) {
			if (0 != (GTK_WIDGET_FLAGS ((GtkWidget*) toplevel) & GTK_REALIZED)) {
				char* _tmp6;
				_tmp6 = NULL;
				gdk_window_set_menu_context (((GtkWidget*) toplevel)->window, _tmp6 = global_menu_gtk_serializer_to_string (self, FALSE));
				_tmp6 = (g_free (_tmp6), NULL);
			}
		}
		g_debug ("globalmenu.vala:114: changed_eh");
		(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
	}
	return (_tmp7 = TRUE, (self == NULL) ? NULL : (self = (g_object_unref (self), NULL)), _tmp7);
}


gboolean global_menu_gtk_menubar_should_be_skipped (GtkMenuBar* menubar) {
	GtkWidget* parent;
	GType panel_applet_type;
	GType gnomenu_menu_bar_type;
	GType panel_menu_bar_type;
	GType gtk_notebook_type;
	g_return_val_if_fail (menubar != NULL, FALSE);
	parent = (GtkWidget*) menubar;
	panel_applet_type = g_type_from_name ("PanelApplet");
	gnomenu_menu_bar_type = g_type_from_name ("GnomenuMenuBar");
	panel_menu_bar_type = g_type_from_name ("PanelMenuBar");
	gtk_notebook_type = g_type_from_name ("GtkNotebook");
	while (GTK_IS_WIDGET (parent)) {
		GType type;
		gboolean _tmp0;
		gboolean _tmp1;
		gboolean _tmp2;
		type = G_TYPE_FROM_INSTANCE ((GObject*) parent);
		_tmp0 = FALSE;
		_tmp1 = FALSE;
		_tmp2 = FALSE;
		if (g_type_is_a (type, panel_applet_type)) {
			_tmp2 = TRUE;
		} else {
			_tmp2 = g_type_is_a (type, gnomenu_menu_bar_type);
		}
		if (_tmp2) {
			_tmp1 = TRUE;
		} else {
			_tmp1 = g_type_is_a (type, panel_menu_bar_type);
		}
		if (_tmp1) {
			_tmp0 = TRUE;
		} else {
			_tmp0 = g_type_is_a (type, gtk_notebook_type);
		}
		if (_tmp0) {
			g_debug ("globalmenu.vala:133: menu bar skipped");
			return TRUE;
		}
		parent = (GtkWidget*) gtk_widget_get_parent (parent);
	}
	g_debug ("globalmenu.vala:138: not skipped");
	return FALSE;
}


void global_menu_gtk_bonobo_plug_widget_hack (GtkWidget* self) {
	GtkWidget* parent;
	g_return_if_fail (self != NULL);
	parent = (GtkWidget*) gtk_widget_get_parent (self);
	while (GTK_IS_WIDGET (parent)) {
		const char* typename;
		typename = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) parent));
		if (strstr (typename, "BonoboDockBand") != NULL) {
			g_debug ("globalmenu.vala:147: Hiding %s", typename);
			gtk_widget_hide (parent);
			break;
		}
		parent = (GtkWidget*) gtk_widget_get_parent (parent);
	}
}


gboolean global_menu_gtk_menubar_get_local (GtkMenuBar* menubar) {
	gboolean is_local;
	g_return_val_if_fail (menubar != NULL, FALSE);
	is_local = TRUE;
	g_object_get ((GObject*) menubar, "local", &is_local, NULL, NULL);
	return is_local;
}


void global_menu_gtk_menubar_set_local (GtkMenuBar* menubar, gboolean value) {
	g_return_if_fail (menubar != NULL);
	g_object_set ((GObject*) menubar, "local", value, NULL, NULL);
}


GtkMenuBar* global_menu_gtk_find_menubar (GtkContainer* widget) {
	GList* children;
	GtkMenuBar* _tmp7;
	g_return_val_if_fail (widget != NULL, NULL);
	children = gtk_container_get_children (widget);
	{
		GList* child_collection;
		GList* child_it;
		child_collection = children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp6;
			GtkWidget* child;
			_tmp6 = NULL;
			child = (_tmp6 = (GtkWidget*) child_it->data, (_tmp6 == NULL) ? NULL : g_object_ref (_tmp6));
			{
				if (GTK_IS_MENU_BAR (child)) {
					GtkMenuBar* _tmp1;
					GtkWidget* _tmp0;
					GtkMenuBar* menubar;
					_tmp1 = NULL;
					_tmp0 = NULL;
					menubar = (_tmp1 = (_tmp0 = child, GTK_IS_MENU_BAR (_tmp0) ? ((GtkMenuBar*) _tmp0) : NULL), (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
					if (global_menu_gtk_menubar_should_be_skipped (menubar)) {
						GtkMenuBar* _tmp2;
						global_menu_gtk_menubar_set_local (menubar, TRUE);
						_tmp2 = NULL;
						return (_tmp2 = NULL, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), (child == NULL) ? NULL : (child = (g_object_unref (child), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp2);
					} else {
						GtkMenuBar* _tmp3;
						global_menu_gtk_menubar_set_local (menubar, FALSE);
						_tmp3 = NULL;
						return (_tmp3 = menubar, (child == NULL) ? NULL : (child = (g_object_unref (child), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp3);
					}
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
				}
				if (GTK_IS_CONTAINER (child)) {
					GtkWidget* _tmp4;
					GtkMenuBar* menubar;
					_tmp4 = NULL;
					menubar = global_menu_gtk_find_menubar ((_tmp4 = child, GTK_IS_CONTAINER (_tmp4) ? ((GtkContainer*) _tmp4) : NULL));
					if (menubar != NULL) {
						GtkMenuBar* _tmp5;
						_tmp5 = NULL;
						return (_tmp5 = menubar, (child == NULL) ? NULL : (child = (g_object_unref (child), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp5);
					}
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
				}
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	}
	_tmp7 = NULL;
	return (_tmp7 = NULL, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp7);
}


static gboolean _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event (GtkWindow* _sender, const GdkEventProperty* event, gpointer self) {
	return global_menu_gtk_window_property_notify_event (_sender, event);
}


static void _global_menu_gtk_window_realize_gtk_widget_realize (GtkWindow* _sender, gpointer self) {
	global_menu_gtk_window_realize (_sender);
}


void global_menu_gtk_unbind_menubar_from_window (GtkMenuBar* menubar, GtkWindow* window) {
	guint _tmp0;
	guint _tmp1;
	g_return_if_fail (menubar != NULL);
	g_return_if_fail (window != NULL);
	g_signal_handlers_disconnect_matched ((GtkWidget*) window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("property-notify-event", GTK_TYPE_WIDGET, &_tmp0, NULL, FALSE), _tmp0), 0, NULL, (GCallback) _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event, NULL);
	g_signal_handlers_disconnect_matched ((GtkWidget*) window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("realize", GTK_TYPE_WIDGET, &_tmp1, NULL, FALSE), _tmp1), 0, NULL, (GCallback) _global_menu_gtk_window_realize_gtk_widget_realize, NULL);
	g_debug ("globalmenu.vala:190: Unbind bar %p from window %p", menubar, window);
}


void global_menu_gtk_bind_menubar_to_window (GtkMenuBar* menubar, GtkWindow* window) {
	g_return_if_fail (menubar != NULL);
	g_return_if_fail (window != NULL);
	gtk_widget_add_events ((GtkWidget*) window, (gint) GDK_PROPERTY_CHANGE_MASK);
	g_signal_connect ((GtkWidget*) window, "property-notify-event", (GCallback) _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event, NULL);
	g_signal_connect ((GtkWidget*) window, "realize", (GCallback) _global_menu_gtk_window_realize_gtk_widget_realize, NULL);
	g_debug ("globalmenu.vala:197: Bind bar %p from window %p", menubar, window);
}


void global_menu_gtk_window_realize (GtkWindow* window) {
	GtkMenuBar* _tmp0;
	GtkMenuBar* menubar;
	g_return_if_fail (window != NULL);
	_tmp0 = NULL;
	menubar = (_tmp0 = dyn_patch_get_menubar ((GtkWidget*) window), (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
	g_signal_emit_by_name (menubar, "dyn-patch-changed", GTK_TYPE_WIDGET, menubar, NULL, NULL);
	(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
}


gboolean global_menu_gtk_window_property_notify_event (GtkWindow* window, const GdkEventProperty* event) {
	g_return_val_if_fail (window != NULL, FALSE);
	if ((*event).atom == gdk_atom_intern ("_NET_GLOBALMENU_MENU_EVENT", FALSE)) {
		char* path;
		GtkMenuBar* _tmp0;
		GtkMenuBar* menubar;
		path = gdk_window_get_menu_event (((GtkWidget*) window)->window);
		_tmp0 = NULL;
		menubar = (_tmp0 = dyn_patch_get_menubar ((GtkWidget*) window), (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
		g_debug ("globalmenu.vala:210: path = %s", path);
		if (menubar != NULL) {
			GtkMenuItem* item;
			item = global_menu_gtk_locator_locate (menubar, path);
			if (item != NULL) {
				gtk_item_select ((GtkItem*) item);
				gtk_menu_item_activate (item);
				g_debug ("globalmenu.vala:216: item %p is activated", item);
				if (gtk_menu_item_get_submenu (item) != NULL) {
					if (global_menu_gtk_hybrid == FALSE) {
						gtk_widget_show ((GtkWidget*) gtk_menu_item_get_submenu (item));
					} else {
						g_debug ("globalmenu.vala:221: client side popup");
						gtk_menu_popup (gtk_menu_item_get_submenu (item), NULL, NULL, NULL, NULL, (guint) 3, gtk_get_current_event_time ());
					}
				}
			} else {
				g_warning ("globalmenu.vala:228: item lookup failure");
			}
			(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
		} else {
			g_warning ("globalmenu.vala:231: menubar lookup failure");
		}
		path = (g_free (path), NULL);
		(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
	}
	return FALSE;
}




