
#ifndef __GTK_MODULES_GLOBALMENU_GLOBALMENU_H__
#define __GTK_MODULES_GLOBALMENU_GLOBALMENU_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define GLOBAL_MENU_GTK_TYPE_FLAGS (global_menu_gtk_flags_get_type ())

typedef enum  {
	GLOBAL_MENU_GTK_FLAGS_NONE = 0,
	GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF = 1,
	GLOBAL_MENU_GTK_FLAGS_HYBRID = 2
} GlobalMenuGTKFlags;


GType global_menu_gtk_flags_get_type (void);
GtkWindow* gtk_widget_get_toplevel_window (GtkWidget* widget);
void gdk_window_set_menu_context (GdkWindow* window, const char* context);
char* gdk_window_get_menu_event (GdkWindow* window);
extern gulong global_menu_gtk_changed_hook_id;
extern gulong global_menu_gtk_attached_hook_id;
extern gulong global_menu_gtk_detached_hook_id;
extern gboolean global_menu_gtk_disable_pixbuf;
extern gboolean global_menu_gtk_hybrid;
void global_menu_gtk_init (GlobalMenuGTKFlags flags);
void global_menu_gtk_uninit (void);
gboolean global_menu_gtk_attached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
gboolean global_menu_gtk_detached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
gboolean global_menu_gtk_changed_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
gboolean global_menu_gtk_menubar_should_be_skipped (GtkMenuBar* menubar);
void global_menu_gtk_bonobo_plug_widget_hack (GtkWidget* self);
gboolean global_menu_gtk_menubar_get_local (GtkMenuBar* menubar);
void global_menu_gtk_menubar_set_local (GtkMenuBar* menubar, gboolean value);
GtkMenuBar* global_menu_gtk_find_menubar (GtkContainer* widget);
void global_menu_gtk_unbind_menubar_from_window (GtkMenuBar* menubar, GtkWindow* window);
void global_menu_gtk_bind_menubar_to_window (GtkMenuBar* menubar, GtkWindow* window);
void global_menu_gtk_window_realize (GtkWindow* window);
gboolean global_menu_gtk_window_property_notify_event (GtkWindow* window, const GdkEventProperty* event);


G_END_DECLS

#endif
