
#include <libgnomenu/application.h>
#include <gnome-menus/gmenu-tree.h>
#include <gobject/gvaluecollector.h>




struct _GnomenuApplicationPrivate {
	char* key;
	char* _readable_name;
	char* _exec_path;
	char* _icon_name;
	GdkPixbuf* _icon_pixbuf;
	gboolean _not_in_menu;
	GtkEventBox* _proxy_item;
	GtkLabel* name_widget;
	GtkLabel* status_widget;
	GtkImage* icon_widget;
};

#define GNOMENU_APPLICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_APPLICATION, GnomenuApplicationPrivate))
enum  {
	GNOMENU_APPLICATION_DUMMY_PROPERTY
};
static void _g_list_free_g_object_unref (GList* self);
GList* gnomenu_application_applications = NULL;
GHashTable* gnomenu_application_dict = NULL;
static gboolean gnomenu_application_initialized = FALSE;
static void _gnomenu_application_application_opened_wnck_screen_application_opened (WnckScreen* _sender, WnckApplication* app, gpointer self);
static void _gnomenu_application_window_opened_wnck_screen_window_opened (WnckScreen* _sender, WnckWindow* window, gpointer self);
static void _gnomenu_application_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self);
static void _gnomenu_application_application_closed_wnck_screen_application_closed (WnckScreen* _sender, WnckApplication* app, gpointer self);
static GnomenuApplication* gnomenu_application_construct (GType object_type);
static GnomenuApplication* gnomenu_application_new (void);
static void gnomenu_application_append_node_r (GMenuTreeDirectory* node);
static void gnomenu_application_window_opened (WnckScreen* s, WnckWindow* wwin);
static void gnomenu_application_window_closed (WnckScreen* s, WnckWindow* wwin);
static void gnomenu_application_application_opened (WnckScreen* s, WnckApplication* wapp);
static void gnomenu_application_application_closed (WnckScreen* s, WnckApplication* wapp);
static void gnomenu_application_create_proxy_item (GnomenuApplication* self);
static char* gnomenu_application_generate_key_from_wnck (WnckApplication* app);
static char* gnomenu_application_get_process_name (WnckApplication* app);
static char* gnomenu_application_generate_key (GMenuTreeEntry* entry);
static void gnomenu_application_set_readable_name (GnomenuApplication* self, const char* value);
static void gnomenu_application_set_exec_path (GnomenuApplication* self, const char* value);
static void gnomenu_application_set_icon_name (GnomenuApplication* self, const char* value);
static void gnomenu_application_set_icon_pixbuf (GnomenuApplication* self, GdkPixbuf* value);
static void gnomenu_application_set_not_in_menu (GnomenuApplication* self, gboolean value);
static gpointer gnomenu_application_parent_class = NULL;
static void gnomenu_application_finalize (GnomenuApplication* obj);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static void _gnomenu_application_application_opened_wnck_screen_application_opened (WnckScreen* _sender, WnckApplication* app, gpointer self) {
	gnomenu_application_application_opened (_sender, app);
}


static void _gnomenu_application_window_opened_wnck_screen_window_opened (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	gnomenu_application_window_opened (_sender, window);
}


static void _gnomenu_application_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	gnomenu_application_window_closed (_sender, window);
}


static void _gnomenu_application_application_closed_wnck_screen_application_closed (WnckScreen* _sender, WnckApplication* app, gpointer self) {
	gnomenu_application_application_closed (_sender, app);
}


void gnomenu_application_init (void) {
	GMenuTreeDirectory* _tmp0;
	GMenuTreeDirectory* node;
	WnckScreen* _tmp1;
	WnckScreen* screen;
	GList* list;
	if (gnomenu_application_initialized) {
		return;
	}
	_tmp0 = NULL;
	node = (_tmp0 = gmenu_tree_get_root_directory (gmenu_tree_lookup ("applications.menu", GMENU_TREE_FLAGS_INCLUDE_EXCLUDED)), (_tmp0 == NULL) ? NULL : gmenu_tree_item_ref (_tmp0));
	gnomenu_application_append_node_r (node);
	gnomenu_application_initialized = TRUE;
	_tmp1 = NULL;
	screen = (_tmp1 = wnck_screen_get_default (), (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
	list = wnck_screen_get_windows (screen);
	{
		GList* wwin_collection;
		GList* wwin_it;
		wwin_collection = list;
		for (wwin_it = wwin_collection; wwin_it != NULL; wwin_it = wwin_it->next) {
			WnckWindow* _tmp3;
			WnckWindow* wwin;
			_tmp3 = NULL;
			wwin = (_tmp3 = (WnckWindow*) wwin_it->data, (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3));
			{
				WnckApplication* _tmp2;
				WnckApplication* wapp;
				_tmp2 = NULL;
				wapp = (_tmp2 = wnck_window_get_application (wwin), (_tmp2 == NULL) ? NULL : g_object_ref (_tmp2));
				gnomenu_application_application_opened (screen, wapp);
				(wwin == NULL) ? NULL : (wwin = (g_object_unref (wwin), NULL));
				(wapp == NULL) ? NULL : (wapp = (g_object_unref (wapp), NULL));
			}
		}
	}
	g_signal_connect (screen, "application-opened", (GCallback) _gnomenu_application_application_opened_wnck_screen_application_opened, NULL);
	g_signal_connect (screen, "window-opened", (GCallback) _gnomenu_application_window_opened_wnck_screen_window_opened, NULL);
	g_signal_connect (screen, "window-closed", (GCallback) _gnomenu_application_window_closed_wnck_screen_window_closed, NULL);
	g_signal_connect (screen, "application-closed", (GCallback) _gnomenu_application_application_closed_wnck_screen_application_closed, NULL);
	(node == NULL) ? NULL : (node = (gmenu_tree_item_unref (node), NULL));
	(screen == NULL) ? NULL : (screen = (g_object_unref (screen), NULL));
}


static GnomenuApplication* gnomenu_application_construct (GType object_type) {
	GnomenuApplication* self;
	self = (GnomenuApplication*) g_type_create_instance (object_type);
	return self;
}


static GnomenuApplication* gnomenu_application_new (void) {
	return gnomenu_application_construct (GNOMENU_TYPE_APPLICATION);
}


GnomenuApplication* gnomenu_application_add_application (const char* key) {
	GnomenuApplication* app;
	GnomenuApplication* rt;
	const char* _tmp0;
	GnomenuApplication* _tmp1;
	GnomenuApplication* _tmp2;
	g_return_val_if_fail (key != NULL, NULL);
	app = gnomenu_application_new ();
	rt = app;
	_tmp0 = NULL;
	g_hash_table_insert (gnomenu_application_dict, (_tmp0 = key, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), app);
	_tmp1 = NULL;
	gnomenu_application_applications = g_list_prepend (gnomenu_application_applications, (_tmp1 = app, app = NULL, _tmp1));
	_tmp2 = NULL;
	return (_tmp2 = rt, (app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL)), _tmp2);
}


GnomenuApplication* gnomenu_application_lookup (const char* key) {
	g_return_val_if_fail (key != NULL, NULL);
	gnomenu_application_init ();
	return (GnomenuApplication*) g_hash_table_lookup (gnomenu_application_dict, key);
}


GnomenuApplication* gnomenu_application_lookup_from_wnck (WnckApplication* wapp) {
	char* key;
	GnomenuApplication* rt;
	GnomenuApplication* _tmp4;
	g_return_val_if_fail (wapp != NULL, NULL);
	gnomenu_application_init ();
	key = gnomenu_application_generate_key_from_wnck (wapp);
	g_debug ("application.vala:97: wnck key = %s", key);
	rt = (GnomenuApplication*) g_hash_table_lookup (gnomenu_application_dict, key);
	if (rt == NULL) {
		GnomenuApplication* app;
		char* _tmp1;
		const char* _tmp0;
		const char* _tmp2;
		GnomenuApplication* _tmp3;
		app = gnomenu_application_new ();
		_tmp1 = NULL;
		_tmp0 = NULL;
		app->priv->key = (_tmp1 = (_tmp0 = key, (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), app->priv->key = (g_free (app->priv->key), NULL), _tmp1);
		gnomenu_application_set_not_in_menu (app, TRUE);
		gnomenu_application_set_readable_name (app, wnck_application_get_name (wapp));
		gnomenu_application_set_exec_path (app, NULL);
		/* NOTE: get_icon_name is not implement in wnck.
		 * Therefore we set icon_pixbuf, which
		 * indeed has a higher priority in switcher.vala
		 * */
		gnomenu_application_set_icon_name (app, wnck_application_get_icon_name (wapp));
		_tmp2 = NULL;
		g_hash_table_insert (gnomenu_application_dict, (_tmp2 = key, (_tmp2 == NULL) ? NULL : g_strdup (_tmp2)), app);
		rt = app;
		_tmp3 = NULL;
		gnomenu_application_applications = g_list_prepend (gnomenu_application_applications, (_tmp3 = app, app = NULL, _tmp3));
		(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
	}
	/* Always use the icon_pixbuf obtained from wnck.*/
	gnomenu_application_set_icon_pixbuf (rt, wnck_application_get_mini_icon (wapp));
	_tmp4 = NULL;
	return (_tmp4 = rt, key = (g_free (key), NULL), _tmp4);
}


void gnomenu_application_update (GnomenuApplication* self) {
	g_return_if_fail (self != NULL);
	if (gnomenu_application_get_proxy_item (self) == NULL) {
		return;
	}
	if (self->wnck_applications != NULL) {
		gint n;
		char* _tmp1;
		n = 0;
		{
			GList* wapp_collection;
			GList* wapp_it;
			wapp_collection = self->wnck_applications;
			for (wapp_it = wapp_collection; wapp_it != NULL; wapp_it = wapp_it->next) {
				WnckApplication* _tmp0;
				WnckApplication* wapp;
				_tmp0 = NULL;
				wapp = (_tmp0 = (WnckApplication*) wapp_it->data, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
				{
					n = n + wnck_application_get_n_windows (wapp);
					(wapp == NULL) ? NULL : (wapp = (g_object_unref (wapp), NULL));
				}
			}
		}
		_tmp1 = NULL;
		gtk_label_set_label (self->priv->status_widget, _tmp1 = g_strdup_printf ("%u instances, %d windows", g_list_length (self->wnck_applications), n));
		_tmp1 = (g_free (_tmp1), NULL);
	} else {
		gtk_label_set_label (self->priv->status_widget, "not launched");
	}
	gtk_label_set_label (self->priv->name_widget, self->priv->_readable_name);
	g_object_set (self->priv->icon_widget, "icon-name", self->priv->_icon_name, NULL);
}


static void gnomenu_application_append_node_r (GMenuTreeDirectory* node) {
	g_return_if_fail (node != NULL);
	{
		GSList* item_collection;
		GSList* item_it;
		item_collection = gmenu_tree_directory_get_contents (node);
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
			GMenuTreeItem* _tmp5;
			GMenuTreeItem* item;
			_tmp5 = NULL;
			item = (_tmp5 = (GMenuTreeItem*) item_it->data, (_tmp5 == NULL) ? NULL : gmenu_tree_item_ref (_tmp5));
			{
				switch (gmenu_tree_item_get_type (item)) {
					case GMENU_TREE_ITEM_ENTRY:
					{
						GMenuTreeEntry* _tmp0;
						GMenuTreeEntry* entry;
						char* key;
						GnomenuApplication* app;
						char* _tmp2;
						const char* _tmp1;
						const char* _tmp3;
						GnomenuApplication* _tmp4;
						_tmp0 = NULL;
						entry = (_tmp0 = (GMenuTreeEntry*) item, (_tmp0 == NULL) ? NULL : gmenu_tree_item_ref (_tmp0));
						key = gnomenu_application_generate_key (entry);
						g_debug ("application.vala:141: gmenu key = %s", key);
						app = gnomenu_application_new ();
						_tmp2 = NULL;
						_tmp1 = NULL;
						app->priv->key = (_tmp2 = (_tmp1 = key, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), app->priv->key = (g_free (app->priv->key), NULL), _tmp2);
						gnomenu_application_set_not_in_menu (app, FALSE);
						gnomenu_application_set_readable_name (app, gmenu_tree_entry_get_name (entry));
						gnomenu_application_set_exec_path (app, gmenu_tree_entry_get_exec (entry));
						gnomenu_application_set_icon_name (app, gmenu_tree_entry_get_icon (entry));
						_tmp3 = NULL;
						g_hash_table_insert (gnomenu_application_dict, (_tmp3 = key, (_tmp3 == NULL) ? NULL : g_strdup (_tmp3)), app);
						_tmp4 = NULL;
						gnomenu_application_applications = g_list_prepend (gnomenu_application_applications, (_tmp4 = app, app = NULL, _tmp4));
						(entry == NULL) ? NULL : (entry = (gmenu_tree_item_unref (entry), NULL));
						key = (g_free (key), NULL);
						(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
						break;
					}
					case GMENU_TREE_ITEM_DIRECTORY:
					{
						gnomenu_application_append_node_r ((GMenuTreeDirectory*) item);
						break;
					}
				}
				(item == NULL) ? NULL : (item = (gmenu_tree_item_unref (item), NULL));
			}
		}
	}
}


static void gnomenu_application_window_opened (WnckScreen* s, WnckWindow* wwin) {
	GnomenuApplication* _tmp0;
	GnomenuApplication* app;
	g_return_if_fail (s != NULL);
	g_return_if_fail (wwin != NULL);
	_tmp0 = NULL;
	app = (_tmp0 = gnomenu_application_lookup_from_wnck (wnck_window_get_application (wwin)), (_tmp0 == NULL) ? NULL : gnomenu_application_ref (_tmp0));
	g_object_set_data ((GObject*) wwin, "gnomenu-app", app);
	gnomenu_application_update (app);
	(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
}


static void gnomenu_application_window_closed (WnckScreen* s, WnckWindow* wwin) {
	GnomenuApplication* _tmp1;
	void* _tmp0;
	GnomenuApplication* app;
	g_return_if_fail (s != NULL);
	g_return_if_fail (wwin != NULL);
	_tmp1 = NULL;
	app = (_tmp1 = (_tmp0 = g_object_get_data ((GObject*) wwin, "gnomenu-app"), GNOMENU_IS_APPLICATION (_tmp0) ? ((GnomenuApplication*) _tmp0) : NULL), (_tmp1 == NULL) ? NULL : gnomenu_application_ref (_tmp1));
	if (app == NULL) {
		(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
		return;
	}
	gnomenu_application_update (app);
	(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
}


static void gnomenu_application_application_opened (WnckScreen* s, WnckApplication* wapp) {
	GnomenuApplication* _tmp0;
	GnomenuApplication* app;
	WnckApplication* _tmp1;
	g_return_if_fail (s != NULL);
	g_return_if_fail (wapp != NULL);
	_tmp0 = NULL;
	app = (_tmp0 = gnomenu_application_lookup_from_wnck (wapp), (_tmp0 == NULL) ? NULL : gnomenu_application_ref (_tmp0));
	_tmp1 = NULL;
	app->wnck_applications = g_list_prepend (app->wnck_applications, (_tmp1 = wapp, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1)));
	gnomenu_application_update (app);
	(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
}


static void gnomenu_application_application_closed (WnckScreen* s, WnckApplication* wapp) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (wapp != NULL);
	{
		GList* app_collection;
		GList* app_it;
		app_collection = gnomenu_application_applications;
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
			GnomenuApplication* _tmp1;
			GnomenuApplication* app;
			_tmp1 = NULL;
			app = (_tmp1 = (GnomenuApplication*) app_it->data, (_tmp1 == NULL) ? NULL : gnomenu_application_ref (_tmp1));
			{
				gboolean _tmp0;
				/*Don't use lookup_from_wnck, since no pid now?*/
				if (g_list_find (app->wnck_applications, wapp) != NULL) {
					app->wnck_applications = g_list_remove (app->wnck_applications, wapp);
					gnomenu_application_update (app);
				}
				_tmp0 = FALSE;
				if (app->wnck_applications == NULL) {
					_tmp0 = app->priv->_not_in_menu;
				} else {
					_tmp0 = FALSE;
				}
				if (_tmp0 = TRUE) {
					/*TODO: After merging the code to Monitor, fire a signal*/
					g_hash_table_remove (gnomenu_application_dict, app->priv->key);
					gnomenu_application_applications = g_list_remove (gnomenu_application_applications, app);
				}
				(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
			}
		}
	}
}


static void gnomenu_application_create_proxy_item (GnomenuApplication* self) {
	GtkEventBox* _tmp0;
	GtkLabel* _tmp1;
	GtkLabel* _tmp2;
	GtkImage* _tmp3;
	GtkHBox* hbox;
	GtkVBox* vbox;
	g_return_if_fail (self != NULL);
	_tmp0 = NULL;
	self->priv->_proxy_item = (_tmp0 = g_object_ref_sink ((GtkEventBox*) gtk_event_box_new ()), (self->priv->_proxy_item == NULL) ? NULL : (self->priv->_proxy_item = (g_object_unref (self->priv->_proxy_item), NULL)), _tmp0);
	_tmp1 = NULL;
	self->priv->name_widget = (_tmp1 = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), (self->priv->name_widget == NULL) ? NULL : (self->priv->name_widget = (g_object_unref (self->priv->name_widget), NULL)), _tmp1);
	_tmp2 = NULL;
	self->priv->status_widget = (_tmp2 = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), (self->priv->status_widget == NULL) ? NULL : (self->priv->status_widget = (g_object_unref (self->priv->status_widget), NULL)), _tmp2);
	_tmp3 = NULL;
	self->priv->icon_widget = (_tmp3 = g_object_ref_sink ((GtkImage*) gtk_image_new ()), (self->priv->icon_widget == NULL) ? NULL : (self->priv->icon_widget = (g_object_unref (self->priv->icon_widget), NULL)), _tmp3);
	hbox = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
	vbox = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
	gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) self->priv->icon_widget, FALSE, FALSE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) vbox, TRUE, TRUE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->name_widget, FALSE, FALSE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->status_widget, FALSE, FALSE, (guint) 0);
	gtk_container_add ((GtkContainer*) self->priv->_proxy_item, (GtkWidget*) hbox);
	gnomenu_application_update (self);
	(hbox == NULL) ? NULL : (hbox = (g_object_unref (hbox), NULL));
	(vbox == NULL) ? NULL : (vbox = (g_object_unref (vbox), NULL));
}


static char* gnomenu_application_generate_key_from_wnck (WnckApplication* app) {
	g_return_val_if_fail (app != NULL, NULL);
	return gnomenu_application_get_process_name (app);
}


static char* gnomenu_application_get_process_name (WnckApplication* app) {
	GError * inner_error;
	char* cmdline;
	gint args_size;
	gint args_length1;
	char** args;
	gboolean _tmp0;
	g_return_val_if_fail (app != NULL, NULL);
	inner_error = NULL;
	cmdline = get_task_name_by_pid (wnck_application_get_pid (app));
	args = (args_length1 = 0, NULL);
	_tmp0 = FALSE;
	if (cmdline == NULL) {
		_tmp0 = TRUE;
	} else {
		_tmp0 = _vala_strcmp0 (cmdline, "") == 0;
	}
	if (_tmp0) {
		const char* _tmp1;
		char* _tmp2;
		_tmp1 = NULL;
		_tmp2 = NULL;
		return (_tmp2 = (_tmp1 = wnck_application_get_name (app), (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), cmdline = (g_free (cmdline), NULL), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), _tmp2);
	}
	{
		char* basename;
		GQuark _tmp7;
		char* _tmp6;
		char* _tmp8;
		g_shell_parse_argv (cmdline, &args_length1, &args, &inner_error);
		if (inner_error != NULL) {
			goto __catch3_g_error;
			goto __finally3;
		}
		basename = g_path_get_basename (args[0]);
		_tmp6 = NULL;
		static GQuark _tmp7_label0 = 0;
		static GQuark _tmp7_label1 = 0;
		static GQuark _tmp7_label2 = 0;
		static GQuark _tmp7_label3 = 0;
		static GQuark _tmp7_label4 = 0;
		_tmp6 = basename;
		_tmp7 = (NULL == _tmp6) ? 0 : g_quark_from_string (_tmp6);
		if ((((_tmp7 == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("mono")))) || (_tmp7 == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("python"))))) || (_tmp7 == ((0 != _tmp7_label2) ? _tmp7_label2 : (_tmp7_label2 = g_quark_from_static_string ("python2.5"))))) || (_tmp7 == ((0 != _tmp7_label3) ? _tmp7_label3 : (_tmp7_label3 = g_quark_from_static_string ("wine")))))
		do {
			const char* _tmp3;
			char* _tmp4;
			_tmp3 = NULL;
			_tmp4 = NULL;
			return (_tmp4 = (_tmp3 = wnck_application_get_name (app), (_tmp3 == NULL) ? NULL : g_strdup (_tmp3)), basename = (g_free (basename), NULL), cmdline = (g_free (cmdline), NULL), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), _tmp4);
		} while (0); else if (_tmp7 == ((0 != _tmp7_label4) ? _tmp7_label4 : (_tmp7_label4 = g_quark_from_static_string ("swriter.bin"))))
		do {
			char* _tmp5;
			_tmp5 = NULL;
			return (_tmp5 = g_strdup ("openoffice.org"), basename = (g_free (basename), NULL), cmdline = (g_free (cmdline), NULL), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), _tmp5);
		} while (0);
		_tmp8 = NULL;
		return (_tmp8 = basename, cmdline = (g_free (cmdline), NULL), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), _tmp8);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError * e;
		e = inner_error;
		inner_error = NULL;
		{
			const char* _tmp9;
			char* _tmp10;
			_tmp9 = NULL;
			_tmp10 = NULL;
			return (_tmp10 = (_tmp9 = wnck_application_get_name (app), (_tmp9 == NULL) ? NULL : g_strdup (_tmp9)), (e == NULL) ? NULL : (e = (g_error_free (e), NULL)), cmdline = (g_free (cmdline), NULL), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), _tmp10);
		}
	}
	__finally3:
	if (inner_error != NULL) {
		cmdline = (g_free (cmdline), NULL);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return NULL;
	}
	cmdline = (g_free (cmdline), NULL);
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
}


/* FIXME: 
 * The following functions are 
 * to be replaced by a manually written normalizer with StringBuilder*/
static char* gnomenu_application_generate_key (GMenuTreeEntry* entry) {
	GError * inner_error;
	gint args_size;
	gint args_length1;
	char** args;
	GString* sb;
	gboolean exec;
	g_return_val_if_fail (entry != NULL, NULL);
	inner_error = NULL;
	args = (args_length1 = 0, NULL);
	sb = g_string_new ("");
	exec = TRUE;
	{
		const char* _tmp4;
		char* _tmp5;
		g_shell_parse_argv (gmenu_tree_entry_get_exec (entry), &args_length1, &args, &inner_error);
		if (inner_error != NULL) {
			goto __catch4_g_error;
			goto __finally4;
		}
		{
			gint i;
			i = 0;
			for (; i < args_length1; i++) {
				if (_vala_strcmp0 (args[i], "env") == 0) {
					while (g_utf8_strchr (args[i + 1], (glong) (-1), (gunichar) '=') != NULL) {
						i++;
					}
					continue;
				}
				if (exec) {
					char* basename;
					GQuark _tmp3;
					char* _tmp2;
					basename = g_path_get_basename (args[i]);
					_tmp2 = NULL;
					static GQuark _tmp3_label0 = 0;
					static GQuark _tmp3_label1 = 0;
					static GQuark _tmp3_label2 = 0;
					static GQuark _tmp3_label3 = 0;
					_tmp2 = basename;
					_tmp3 = (NULL == _tmp2) ? 0 : g_quark_from_string (_tmp2);
					if ((((_tmp3 == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("mono")))) || (_tmp3 == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("wine"))))) || (_tmp3 == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("python"))))) || (_tmp3 == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("python2.5")))))
					do {
						const char* _tmp0;
						char* _tmp1;
						_tmp0 = NULL;
						_tmp1 = NULL;
						return (_tmp1 = (_tmp0 = gmenu_tree_entry_get_name (entry), (_tmp0 == NULL) ? NULL : g_strdup (_tmp0)), basename = (g_free (basename), NULL), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), (sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL)), _tmp1);
					} while (0);
					g_string_append (sb, basename);
					exec = FALSE;
					basename = (g_free (basename), NULL);
				} else {
				}
			}
		}
		/*ignore other parameters */
		_tmp4 = NULL;
		_tmp5 = NULL;
		return (_tmp5 = (_tmp4 = sb->str, (_tmp4 == NULL) ? NULL : g_strdup (_tmp4)), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), (sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL)), _tmp5);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * e;
		e = inner_error;
		inner_error = NULL;
		{
			const char* _tmp6;
			char* _tmp7;
			_tmp6 = NULL;
			_tmp7 = NULL;
			return (_tmp7 = (_tmp6 = gmenu_tree_entry_get_exec (entry), (_tmp6 == NULL) ? NULL : g_strdup (_tmp6)), (e == NULL) ? NULL : (e = (g_error_free (e), NULL)), args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL), (sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL)), _tmp7);
		}
	}
	__finally4:
	if (inner_error != NULL) {
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		(sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return NULL;
	}
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
	(sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL));
}


const char* gnomenu_application_get_readable_name (GnomenuApplication* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_readable_name;
}


static void gnomenu_application_set_readable_name (GnomenuApplication* self, const char* value) {
	char* _tmp2;
	const char* _tmp1;
	g_return_if_fail (self != NULL);
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_readable_name = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), self->priv->_readable_name = (g_free (self->priv->_readable_name), NULL), _tmp2);
}


const char* gnomenu_application_get_exec_path (GnomenuApplication* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_exec_path;
}


static void gnomenu_application_set_exec_path (GnomenuApplication* self, const char* value) {
	char* _tmp2;
	const char* _tmp1;
	g_return_if_fail (self != NULL);
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_exec_path = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), self->priv->_exec_path = (g_free (self->priv->_exec_path), NULL), _tmp2);
}


const char* gnomenu_application_get_icon_name (GnomenuApplication* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_icon_name;
}


static void gnomenu_application_set_icon_name (GnomenuApplication* self, const char* value) {
	char* _tmp2;
	const char* _tmp1;
	g_return_if_fail (self != NULL);
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_icon_name = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), self->priv->_icon_name = (g_free (self->priv->_icon_name), NULL), _tmp2);
}


GdkPixbuf* gnomenu_application_get_icon_pixbuf (GnomenuApplication* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_icon_pixbuf;
}


static void gnomenu_application_set_icon_pixbuf (GnomenuApplication* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp2;
	GdkPixbuf* _tmp1;
	g_return_if_fail (self != NULL);
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_icon_pixbuf = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1)), (self->priv->_icon_pixbuf == NULL) ? NULL : (self->priv->_icon_pixbuf = (g_object_unref (self->priv->_icon_pixbuf), NULL)), _tmp2);
}


gboolean gnomenu_application_get_not_in_menu (GnomenuApplication* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return self->priv->_not_in_menu;
}


static void gnomenu_application_set_not_in_menu (GnomenuApplication* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_not_in_menu = value;
}


GtkWidget* gnomenu_application_get_proxy_item (GnomenuApplication* self) {
	g_return_val_if_fail (self != NULL, NULL);
	if (self->priv->_proxy_item == NULL) {
		gnomenu_application_create_proxy_item (self);
	}
	return (GtkWidget*) self->priv->_proxy_item;
}


static void gnomenu_value_application_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void gnomenu_value_application_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		gnomenu_application_unref (value->data[0].v_pointer);
	}
}


static void gnomenu_value_application_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnomenu_application_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer gnomenu_value_application_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* gnomenu_value_application_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GnomenuApplication* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnomenu_application_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* gnomenu_value_application_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GnomenuApplication** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnomenu_application_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* gnomenu_param_spec_application (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GnomenuParamSpecApplication* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNOMENU_TYPE_APPLICATION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer gnomenu_value_get_application (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_TYPE_APPLICATION), NULL);
	return value->data[0].v_pointer;
}


void gnomenu_value_set_application (GValue* value, gpointer v_object) {
	GnomenuApplication* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_TYPE_APPLICATION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNOMENU_TYPE_APPLICATION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnomenu_application_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnomenu_application_unref (old);
	}
}


static void gnomenu_application_class_init (GnomenuApplicationClass * klass) {
	gnomenu_application_parent_class = g_type_class_peek_parent (klass);
	GNOMENU_APPLICATION_CLASS (klass)->finalize = gnomenu_application_finalize;
	g_type_class_add_private (klass, sizeof (GnomenuApplicationPrivate));
	gnomenu_application_dict = g_hash_table_new (g_str_hash, g_str_equal);
}


static void gnomenu_application_instance_init (GnomenuApplication * self) {
	self->priv = GNOMENU_APPLICATION_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void gnomenu_application_finalize (GnomenuApplication* obj) {
	GnomenuApplication * self;
	self = GNOMENU_APPLICATION (obj);
	self->priv->key = (g_free (self->priv->key), NULL);
	self->priv->_readable_name = (g_free (self->priv->_readable_name), NULL);
	self->priv->_exec_path = (g_free (self->priv->_exec_path), NULL);
	self->priv->_icon_name = (g_free (self->priv->_icon_name), NULL);
	(self->priv->_icon_pixbuf == NULL) ? NULL : (self->priv->_icon_pixbuf = (g_object_unref (self->priv->_icon_pixbuf), NULL));
	(self->wnck_applications == NULL) ? NULL : (self->wnck_applications = (_g_list_free_g_object_unref (self->wnck_applications), NULL));
	(self->priv->_proxy_item == NULL) ? NULL : (self->priv->_proxy_item = (g_object_unref (self->priv->_proxy_item), NULL));
	(self->priv->name_widget == NULL) ? NULL : (self->priv->name_widget = (g_object_unref (self->priv->name_widget), NULL));
	(self->priv->status_widget == NULL) ? NULL : (self->priv->status_widget = (g_object_unref (self->priv->status_widget), NULL));
	(self->priv->icon_widget == NULL) ? NULL : (self->priv->icon_widget = (g_object_unref (self->priv->icon_widget), NULL));
}


GType gnomenu_application_get_type (void) {
	static GType gnomenu_application_type_id = 0;
	if (gnomenu_application_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { gnomenu_value_application_init, gnomenu_value_application_free_value, gnomenu_value_application_copy_value, gnomenu_value_application_peek_pointer, "p", gnomenu_value_application_collect_value, "p", gnomenu_value_application_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuApplication), 0, (GInstanceInitFunc) gnomenu_application_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		gnomenu_application_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnomenuApplication", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return gnomenu_application_type_id;
}


gpointer gnomenu_application_ref (gpointer instance) {
	GnomenuApplication* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void gnomenu_application_unref (gpointer instance) {
	GnomenuApplication* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNOMENU_APPLICATION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




