
#include <libgnomenu/helper.h>








GType gnomenu_background_type_get_type (void) {
	static GType gnomenu_background_type_type_id = 0;
	if (G_UNLIKELY (gnomenu_background_type_type_id == 0)) {
		static const GEnumValue values[] = {{GNOMENU_BACKGROUND_TYPE_NONE, "GNOMENU_BACKGROUND_TYPE_NONE", "none"}, {GNOMENU_BACKGROUND_TYPE_COLOR, "GNOMENU_BACKGROUND_TYPE_COLOR", "color"}, {GNOMENU_BACKGROUND_TYPE_PIXMAP, "GNOMENU_BACKGROUND_TYPE_PIXMAP", "pixmap"}, {0, NULL, NULL}};
		gnomenu_background_type_type_id = g_enum_register_static ("GnomenuBackgroundType", values);
	}
	return gnomenu_background_type_type_id;
}



GType gnomenu_gravity_get_type (void) {
	static GType gnomenu_gravity_type_id = 0;
	if (G_UNLIKELY (gnomenu_gravity_type_id == 0)) {
		static const GEnumValue values[] = {{GNOMENU_GRAVITY_DOWN, "GNOMENU_GRAVITY_DOWN", "down"}, {GNOMENU_GRAVITY_UP, "GNOMENU_GRAVITY_UP", "up"}, {GNOMENU_GRAVITY_LEFT, "GNOMENU_GRAVITY_LEFT", "left"}, {GNOMENU_GRAVITY_RIGHT, "GNOMENU_GRAVITY_RIGHT", "right"}, {0, NULL, NULL}};
		gnomenu_gravity_type_id = g_enum_register_static ("GnomenuGravity", values);
	}
	return gnomenu_gravity_type_id;
}


/*Text Gravity, differ from Gdk.Gravity
Rarely used: up-side-down!*/
double gnomenu_gravity_to_text_angle (GnomenuGravity g) {
	switch (g) {
		case GNOMENU_GRAVITY_UP:
		{
			return (double) 180;
		}
		case GNOMENU_GRAVITY_LEFT:
		{
			return (double) 270;
		}
		case GNOMENU_GRAVITY_RIGHT:
		{
			return (double) 90;
		}
		default:
		{
			return (double) 0;
		}
	}
}


GtkArrowType gnomenu_gravity_to_arrow_type (GnomenuGravity g) {
	switch (g) {
		case GNOMENU_GRAVITY_UP:
		{
			return GTK_ARROW_UP;
		}
		case GNOMENU_GRAVITY_LEFT:
		{
			return GTK_ARROW_LEFT;
		}
		case GNOMENU_GRAVITY_RIGHT:
		{
			return GTK_ARROW_RIGHT;
		}
		default:
		{
			return GTK_ARROW_DOWN;
		}
	}
}




