
#include <libgnomenu/interface-item.h>








GType gnomenu_item_type_get_type (void) {
	static GType gnomenu_item_type_type_id = 0;
	if (G_UNLIKELY (gnomenu_item_type_type_id == 0)) {
		static const GEnumValue values[] = {{GNOMENU_ITEM_TYPE_NORMAL, "GNOMENU_ITEM_TYPE_NORMAL", "normal"}, {GNOMENU_ITEM_TYPE_CHECK, "GNOMENU_ITEM_TYPE_CHECK", "check"}, {GNOMENU_ITEM_TYPE_RADIO, "GNOMENU_ITEM_TYPE_RADIO", "radio"}, {GNOMENU_ITEM_TYPE_IMAGE, "GNOMENU_ITEM_TYPE_IMAGE", "image"}, {GNOMENU_ITEM_TYPE_SEPARATOR, "GNOMENU_ITEM_TYPE_SEPARATOR", "separator"}, {GNOMENU_ITEM_TYPE_ARROW, "GNOMENU_ITEM_TYPE_ARROW", "arrow"}, {GNOMENU_ITEM_TYPE_ICON, "GNOMENU_ITEM_TYPE_ICON", "icon"}, {0, NULL, NULL}};
		gnomenu_item_type_type_id = g_enum_register_static ("GnomenuItemType", values);
	}
	return gnomenu_item_type_type_id;
}



GType gnomenu_item_state_get_type (void) {
	static GType gnomenu_item_state_type_id = 0;
	if (G_UNLIKELY (gnomenu_item_state_type_id == 0)) {
		static const GEnumValue values[] = {{GNOMENU_ITEM_STATE_UNTOGGLED, "GNOMENU_ITEM_STATE_UNTOGGLED", "untoggled"}, {GNOMENU_ITEM_STATE_TOGGLED, "GNOMENU_ITEM_STATE_TOGGLED", "toggled"}, {GNOMENU_ITEM_STATE_TRISTATE, "GNOMENU_ITEM_STATE_TRISTATE", "tristate"}, {0, NULL, NULL}};
		gnomenu_item_state_type_id = g_enum_register_static ("GnomenuItemState", values);
	}
	return gnomenu_item_state_type_id;
}


gboolean gnomenu_item_is_child_of (GnomenuItem* self, GnomenuItem* possible_parent) {
	GnomenuShell* parent_shell;
	GnomenuItem* _tmp0;
	GnomenuItem* parent_item;
	GnomenuItem* _tmp6;
	GnomenuItem* _tmp5;
	GnomenuShell* _tmp4;
	GnomenuShell* _tmp3;
	GnomenuItem* _tmp2;
	GnomenuItem* _tmp1;
	gboolean _tmp8;
	g_return_val_if_fail (possible_parent != NULL, FALSE);
	parent_shell = NULL;
	_tmp0 = NULL;
	parent_item = (_tmp0 = self, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
	_tmp6 = NULL;
	_tmp5 = NULL;
	_tmp4 = NULL;
	_tmp3 = NULL;
	_tmp2 = NULL;
	_tmp1 = NULL;
	for (parent_item = (_tmp2 = (_tmp1 = self, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1)), (parent_item == NULL) ? NULL : (parent_item = (g_object_unref (parent_item), NULL)), _tmp2); TRUE; parent_shell = (_tmp4 = (_tmp3 = gnomenu_item_get_shell (parent_item), (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3)), (parent_shell == NULL) ? NULL : (parent_shell = (g_object_unref (parent_shell), NULL)), _tmp4), parent_item = (_tmp6 = (_tmp5 = gnomenu_shell_get_owner (parent_shell), (_tmp5 == NULL) ? NULL : g_object_ref (_tmp5)), (parent_item == NULL) ? NULL : (parent_item = (g_object_unref (parent_item), NULL)), _tmp6)) {
		gboolean _tmp7;
		_tmp7 = FALSE;
		if (parent_item != NULL) {
			_tmp7 = parent_item != possible_parent;
		} else {
			_tmp7 = FALSE;
		}
		if (!_tmp7) {
			break;
		}
		continue;
	}
	return (_tmp8 = parent_item != NULL, (parent_shell == NULL) ? NULL : (parent_shell = (g_object_unref (parent_shell), NULL)), (parent_item == NULL) ? NULL : (parent_item = (g_object_unref (parent_item), NULL)), _tmp8);
}


GnomenuItemState gnomenu_item_state_from_string (const char* str) {
	GQuark _tmp4;
	char* _tmp3;
	_tmp3 = NULL;
	static GQuark _tmp4_label0 = 0;
	static GQuark _tmp4_label1 = 0;
	static GQuark _tmp4_label2 = 0;
	static GQuark _tmp4_label3 = 0;
	static GQuark _tmp4_label4 = 0;
	static GQuark _tmp4_label5 = 0;
	static GQuark _tmp4_label6 = 0;
	static GQuark _tmp4_label7 = 0;
	_tmp3 = str;
	_tmp4 = (NULL == _tmp3) ? 0 : g_quark_from_string (_tmp3);
	if ((((_tmp4 == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("true")))) || (_tmp4 == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("toggled"))))) || (_tmp4 == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("t"))))) || (_tmp4 == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("1")))))
	do {
		return GNOMENU_ITEM_STATE_TOGGLED;
	} while (0); else if ((((_tmp4 == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("false")))) || (_tmp4 == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("untoggled"))))) || (_tmp4 == ((0 != _tmp4_label6) ? _tmp4_label6 : (_tmp4_label6 = g_quark_from_static_string ("f"))))) || (_tmp4 == ((0 != _tmp4_label7) ? _tmp4_label7 : (_tmp4_label7 = g_quark_from_static_string ("0")))))
	do {
		return GNOMENU_ITEM_STATE_UNTOGGLED;
	} while (0); else
	do {
		return GNOMENU_ITEM_STATE_TRISTATE;
	} while (0);
}


const char* gnomenu_item_state_to_string (GnomenuItemState state) {
	switch (state) {
		case GNOMENU_ITEM_STATE_UNTOGGLED:
		{
			return "untoggled";
		}
		case GNOMENU_ITEM_STATE_TOGGLED:
		{
			return "toggled";
		}
		case GNOMENU_ITEM_STATE_TRISTATE:
		{
			return NULL;
		}
	}
	return NULL;
}


GnomenuItemType gnomenu_item_type_from_string (const char* str) {
	GQuark _tmp8;
	char* _tmp7;
	_tmp7 = NULL;
	static GQuark _tmp8_label0 = 0;
	static GQuark _tmp8_label1 = 0;
	static GQuark _tmp8_label2 = 0;
	static GQuark _tmp8_label3 = 0;
	static GQuark _tmp8_label4 = 0;
	static GQuark _tmp8_label5 = 0;
	static GQuark _tmp8_label6 = 0;
	static GQuark _tmp8_label7 = 0;
	static GQuark _tmp8_label8 = 0;
	static GQuark _tmp8_label9 = 0;
	static GQuark _tmp8_label10 = 0;
	_tmp7 = str;
	_tmp8 = (NULL == _tmp7) ? 0 : g_quark_from_string (_tmp7);
	if ((_tmp8 == ((0 != _tmp8_label0) ? _tmp8_label0 : (_tmp8_label0 = g_quark_from_static_string ("check")))) || (_tmp8 == ((0 != _tmp8_label1) ? _tmp8_label1 : (_tmp8_label1 = g_quark_from_static_string ("c")))))
	do {
		return GNOMENU_ITEM_TYPE_CHECK;
	} while (0); else if ((_tmp8 == ((0 != _tmp8_label2) ? _tmp8_label2 : (_tmp8_label2 = g_quark_from_static_string ("radio")))) || (_tmp8 == ((0 != _tmp8_label3) ? _tmp8_label3 : (_tmp8_label3 = g_quark_from_static_string ("r")))))
	do {
		return GNOMENU_ITEM_TYPE_RADIO;
	} while (0); else if ((_tmp8 == ((0 != _tmp8_label4) ? _tmp8_label4 : (_tmp8_label4 = g_quark_from_static_string ("image")))) || (_tmp8 == ((0 != _tmp8_label5) ? _tmp8_label5 : (_tmp8_label5 = g_quark_from_static_string ("i")))))
	do {
		return GNOMENU_ITEM_TYPE_IMAGE;
	} while (0); else if ((_tmp8 == ((0 != _tmp8_label6) ? _tmp8_label6 : (_tmp8_label6 = g_quark_from_static_string ("arrow")))) || (_tmp8 == ((0 != _tmp8_label7) ? _tmp8_label7 : (_tmp8_label7 = g_quark_from_static_string ("a")))))
	do {
		return GNOMENU_ITEM_TYPE_ARROW;
	} while (0); else if ((_tmp8 == ((0 != _tmp8_label8) ? _tmp8_label8 : (_tmp8_label8 = g_quark_from_static_string ("separator")))) || (_tmp8 == ((0 != _tmp8_label9) ? _tmp8_label9 : (_tmp8_label9 = g_quark_from_static_string ("s")))))
	do {
		return GNOMENU_ITEM_TYPE_SEPARATOR;
	} while (0); else if (_tmp8 == ((0 != _tmp8_label10) ? _tmp8_label10 : (_tmp8_label10 = g_quark_from_static_string ("icon"))))
	do {
		return GNOMENU_ITEM_TYPE_ICON;
	} while (0); else
	do {
		return GNOMENU_ITEM_TYPE_NORMAL;
	} while (0);
}


gboolean gnomenu_item_type_has_label (GnomenuItemType type) {
	gboolean _tmp0;
	gboolean _tmp1;
	gboolean _tmp2;
	_tmp0 = FALSE;
	_tmp1 = FALSE;
	_tmp2 = FALSE;
	if (type == GNOMENU_ITEM_TYPE_NORMAL) {
		_tmp2 = TRUE;
	} else {
		_tmp2 = type == GNOMENU_ITEM_TYPE_IMAGE;
	}
	if (_tmp2) {
		_tmp1 = TRUE;
	} else {
		_tmp1 = type == GNOMENU_ITEM_TYPE_CHECK;
	}
	if (_tmp1) {
		_tmp0 = TRUE;
	} else {
		_tmp0 = type == GNOMENU_ITEM_TYPE_RADIO;
	}
	if (_tmp0) {
		return TRUE;
	}
	return FALSE;
}


const char* gnomenu_item_type_to_string (GnomenuItemType type) {
	switch (type) {
		case GNOMENU_ITEM_TYPE_CHECK:
		{
			return "check";
		}
		case GNOMENU_ITEM_TYPE_RADIO:
		{
			return "radio";
		}
		case GNOMENU_ITEM_TYPE_NORMAL:
		{
			return NULL;
		}
		case GNOMENU_ITEM_TYPE_IMAGE:
		{
			return "image";
		}
		case GNOMENU_ITEM_TYPE_ICON:
		{
			return "icon";
		}
		case GNOMENU_ITEM_TYPE_ARROW:
		{
			return "arrow";
		}
		case GNOMENU_ITEM_TYPE_SEPARATOR:
		{
			return "separator";
		}
	}
	return NULL;
}


GnomenuShell* gnomenu_item_get_shell (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_shell (self);
}


GnomenuShell* gnomenu_item_get_sub_shell (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_sub_shell (self);
}


gboolean gnomenu_item_get_has_sub_shell (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_has_sub_shell (self);
}


void gnomenu_item_set_has_sub_shell (GnomenuItem* self, gboolean value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_has_sub_shell (self, value);
}


gboolean gnomenu_item_get_client_side_sub_shell (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_client_side_sub_shell (self);
}


void gnomenu_item_set_client_side_sub_shell (GnomenuItem* self, gboolean value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_client_side_sub_shell (self, value);
}


GnomenuShell* gnomenu_item_get_toplevel_shell (GnomenuItem* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return gnomenu_shell_get_toplevel_shell (gnomenu_item_get_shell (self));
}


gint gnomenu_item_get_item_position (GnomenuItem* self) {
	g_return_val_if_fail (self != NULL, 0);
	return gnomenu_shell_get_item_position (gnomenu_item_get_shell (self), self);
}


char* gnomenu_item_get_item_id (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_id (self);
}


void gnomenu_item_set_item_id (GnomenuItem* self, const char* value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_id (self, value);
}


GnomenuItemType gnomenu_item_get_item_type (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_type (self);
}


void gnomenu_item_set_item_type (GnomenuItem* self, GnomenuItemType value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_type (self, value);
}


gboolean gnomenu_item_get_item_use_underline (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_use_underline (self);
}


void gnomenu_item_set_item_use_underline (GnomenuItem* self, gboolean value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_use_underline (self, value);
}


gboolean gnomenu_item_get_item_sensitive (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_sensitive (self);
}


void gnomenu_item_set_item_sensitive (GnomenuItem* self, gboolean value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_sensitive (self, value);
}


gboolean gnomenu_item_get_item_visible (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_visible (self);
}


void gnomenu_item_set_item_visible (GnomenuItem* self, gboolean value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_visible (self, value);
}


GnomenuItemState gnomenu_item_get_item_state (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_state (self);
}


void gnomenu_item_set_item_state (GnomenuItem* self, GnomenuItemState value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_state (self, value);
}


char* gnomenu_item_get_item_label (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_label (self);
}


void gnomenu_item_set_item_label (GnomenuItem* self, const char* value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_label (self, value);
}


char* gnomenu_item_get_item_icon (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_icon (self);
}


void gnomenu_item_set_item_icon (GnomenuItem* self, const char* value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_icon (self, value);
}


char* gnomenu_item_get_item_accel_text (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_accel_text (self);
}


void gnomenu_item_set_item_accel_text (GnomenuItem* self, const char* value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_accel_text (self, value);
}


char* gnomenu_item_get_item_font (GnomenuItem* self) {
	return GNOMENU_ITEM_GET_INTERFACE (self)->get_item_font (self);
}


void gnomenu_item_set_item_font (GnomenuItem* self, const char* value) {
	GNOMENU_ITEM_GET_INTERFACE (self)->set_item_font (self, value);
}


char* gnomenu_item_get_item_path_name (GnomenuItem* self) {
	g_return_val_if_fail (self != NULL, NULL);
	if (gnomenu_item_get_item_id (self) != NULL) {
		const char* _tmp0;
		_tmp0 = NULL;
		return (_tmp0 = gnomenu_item_get_item_id (self), (_tmp0 == NULL) ? NULL : g_strdup (_tmp0));
	} else {
		return g_strdup_printf ("%i", gnomenu_item_get_item_position (self));
	}
}


char* gnomenu_item_get_item_path (GnomenuItem* self) {
	GString* sb;
	GnomenuItem* _tmp0;
	GnomenuItem* item;
	GnomenuShell* _tmp1;
	GnomenuShell* parent;
	char* _tmp2;
	const char* _tmp9;
	char* _tmp10;
	g_return_val_if_fail (self != NULL, NULL);
	sb = g_string_new ("");
	_tmp0 = NULL;
	item = (_tmp0 = self, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
	_tmp1 = NULL;
	parent = (_tmp1 = gnomenu_item_get_shell (item), (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
	_tmp2 = NULL;
	g_string_append (sb, _tmp2 = gnomenu_item_get_item_path_name (self));
	_tmp2 = (g_free (_tmp2), NULL);
	while (parent != NULL) {
		GnomenuItem* _tmp5;
		GnomenuItem* _tmp4;
		GnomenuItem* _tmp3;
		char* _tmp6;
		GnomenuShell* _tmp8;
		GnomenuShell* _tmp7;
		_tmp5 = NULL;
		_tmp4 = NULL;
		_tmp3 = NULL;
		item = (_tmp5 = (_tmp4 = (_tmp3 = gnomenu_shell_get_owner (parent), GNOMENU_IS_ITEM (_tmp3) ? ((GnomenuItem*) _tmp3) : NULL), (_tmp4 == NULL) ? NULL : g_object_ref (_tmp4)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp5);
		if (item == NULL) {
			break;
		}
		g_string_prepend_unichar (sb, (gunichar) '/');
		_tmp6 = NULL;
		g_string_prepend (sb, _tmp6 = gnomenu_item_get_item_path_name (item));
		_tmp6 = (g_free (_tmp6), NULL);
		_tmp8 = NULL;
		_tmp7 = NULL;
		parent = (_tmp8 = (_tmp7 = gnomenu_item_get_shell (item), (_tmp7 == NULL) ? NULL : g_object_ref (_tmp7)), (parent == NULL) ? NULL : (parent = (g_object_unref (parent), NULL)), _tmp8);
	}
	g_string_prepend_unichar (sb, (gunichar) '/');
	_tmp9 = NULL;
	_tmp10 = NULL;
	return (_tmp10 = (_tmp9 = sb->str, (_tmp9 == NULL) ? NULL : g_strdup (_tmp9)), (sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (parent == NULL) ? NULL : (parent = (g_object_unref (parent), NULL)), _tmp10);
}


static void gnomenu_item_base_init (GnomenuItemIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_object ("shell", "shell", "shell", GNOMENU_TYPE_SHELL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_object ("sub-shell", "sub-shell", "sub-shell", GNOMENU_TYPE_SHELL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("has-sub-shell", "has-sub-shell", "has-sub-shell", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("client-side-sub-shell", "client-side-sub-shell", "client-side-sub-shell", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("item-id", "item-id", "item-id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_enum ("item-type", "item-type", "item-type", GNOMENU_TYPE_ITEM_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("item-use-underline", "item-use-underline", "item-use-underline", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("item-sensitive", "item-sensitive", "item-sensitive", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("item-visible", "item-visible", "item-visible", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_enum ("item-state", "item-state", "item-state", GNOMENU_TYPE_ITEM_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("item-label", "item-label", "item-label", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("item-icon", "item-icon", "item-icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("item-accel-text", "item-accel-text", "item-accel-text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_string ("item-font", "item-font", "item-font", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


GType gnomenu_item_get_type (void) {
	static GType gnomenu_item_type_id = 0;
	if (gnomenu_item_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuItemIface), (GBaseInitFunc) gnomenu_item_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		gnomenu_item_type_id = g_type_register_static (G_TYPE_INTERFACE, "GnomenuItem", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gnomenu_item_type_id, G_TYPE_OBJECT);
	}
	return gnomenu_item_type_id;
}




