
#include <libgnomenu/interface-shell.h>
#include <libgnomenu/interface-item.h>







GnomenuItem* gnomenu_shell_get_item (GnomenuShell* self, gint position) {
	return GNOMENU_SHELL_GET_INTERFACE (self)->get_item (self, position);
}


GnomenuItem* gnomenu_shell_get_item_by_id (GnomenuShell* self, const char* id) {
	return GNOMENU_SHELL_GET_INTERFACE (self)->get_item_by_id (self, id);
}


gint gnomenu_shell_get_item_position (GnomenuShell* self, GnomenuItem* item) {
	return GNOMENU_SHELL_GET_INTERFACE (self)->get_item_position (self, item);
}


GnomenuItem* gnomenu_shell_get_owner (GnomenuShell* self) {
	return GNOMENU_SHELL_GET_INTERFACE (self)->get_owner (self);
}


gint gnomenu_shell_get_length (GnomenuShell* self) {
	return GNOMENU_SHELL_GET_INTERFACE (self)->get_length (self);
}


void gnomenu_shell_set_length (GnomenuShell* self, gint value) {
	GNOMENU_SHELL_GET_INTERFACE (self)->set_length (self, value);
}


GnomenuShell* gnomenu_shell_get_toplevel_shell (GnomenuShell* self) {
	g_return_val_if_fail (self != NULL, NULL);
	if (gnomenu_shell_get_owner (self) != NULL) {
		return gnomenu_item_get_toplevel_shell (gnomenu_shell_get_owner (self));
	}
	return self;
}


static void gnomenu_shell_base_init (GnomenuShellIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_object ("owner", "owner", "owner", GNOMENU_TYPE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
		g_object_interface_install_property (iface, g_param_spec_int ("length", "length", "length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


GType gnomenu_shell_get_type (void) {
	static GType gnomenu_shell_type_id = 0;
	if (gnomenu_shell_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuShellIface), (GBaseInitFunc) gnomenu_shell_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		gnomenu_shell_type_id = g_type_register_static (G_TYPE_INTERFACE, "GnomenuShell", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gnomenu_shell_type_id, G_TYPE_OBJECT);
	}
	return gnomenu_shell_type_id;
}




