
#include <libgnomenu/label.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

typedef struct _GnomenuMenuLabelChildPropBag GnomenuMenuLabelChildPropBag;

#define GNOMENU_MENU_LABEL_TYPE_CHILD_PROP_BAG (gnomenu_menu_label_child_prop_bag_get_type ())

struct _GnomenuMenuLabelChildPropBag {
	PangoAlignment alignment;
	gint padding;
	gboolean ellipsized;
};



static char* bool_to_string (gboolean self);
struct _GnomenuMenuLabelPrivate {
	GtkLabel* _label_widget;
	GtkLabel* _accel_widget;
	char* _label;
	char* _accel;
	gboolean _use_underline;
	GnomenuGravity _gravity;
	GList* children;
	GHashTable* props;
};

#define GNOMENU_MENU_LABEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_MENU_LABEL, GnomenuMenuLabelPrivate))
enum  {
	GNOMENU_MENU_LABEL_DUMMY_PROPERTY,
	GNOMENU_MENU_LABEL_ACCEL,
	GNOMENU_MENU_LABEL_USE_UNDERLINE,
	GNOMENU_MENU_LABEL_MAX_WIDTH_CHARS,
	GNOMENU_MENU_LABEL_LABEL,
	GNOMENU_MENU_LABEL_GRAVITY,
	GNOMENU_MENU_LABEL_LABEL_WIDGET,
	GNOMENU_MENU_LABEL_MNEMONIC_KEYVAL
};
#define GNOMENU_MENU_LABEL_PROP_ALIGNMENT 1234
#define GNOMENU_MENU_LABEL_PROP_PADDING 1235
#define GNOMENU_MENU_LABEL_PROP_ELLIPSIZED 1236
static gboolean gnomenu_menu_label_real_mnemonic_activate (GtkWidget* base, gboolean arg1);
static gboolean __lambda0 (GtkWidget* obj, gboolean arg1, GnomenuMenuLabel* self);
static gboolean ___lambda0_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self);
static void gnomenu_menu_label_real_add (GtkContainer* base, GtkWidget* child);
static void gnomenu_menu_label_real_remove (GtkContainer* base, GtkWidget* child);
static void gnomenu_menu_label_real_style_set (GtkWidget* base, GtkStyle* old_style);
static void gnomenu_menu_label_real_forall (GtkContainer* base, gboolean include_internals, GtkCallback callback, void* callback_target);
static void gnomenu_menu_label_real_size_request (GtkWidget* base, GtkRequisition* r);
static void gnomenu_menu_label_real_size_allocate (GtkWidget* base, const GdkRectangle* a);
static void gnomenu_menu_label_real_get_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec);
static void gnomenu_menu_label_real_set_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec);
static void gnomenu_menu_label_update_label_gravity (GnomenuMenuLabel* self, GtkLabel* child);
static void _g_free_gdestroy_notify (void* data);
static GObject * gnomenu_menu_label_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static GnomenuMenuLabelChildPropBag* gnomenu_menu_label_child_prop_bag_dup (const GnomenuMenuLabelChildPropBag* self);
static void gnomenu_menu_label_child_prop_bag_free (GnomenuMenuLabelChildPropBag* self);
static GType gnomenu_menu_label_child_prop_bag_get_type (void);
static gpointer gnomenu_menu_label_parent_class = NULL;
static void gnomenu_menu_label_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



static char* bool_to_string (gboolean self) {
	if (self) {
		return g_strdup ("true");
	} else {
		return g_strdup ("false");
	}
}


GnomenuMenuLabel* gnomenu_menu_label_construct (GType object_type) {
	GnomenuMenuLabel * self;
	self = g_object_newv (object_type, 0, NULL);
	g_object_set ((GtkWidget*) self->priv->_accel_widget, "visible", FALSE, NULL);
	g_object_set ((GtkWidget*) self->priv->_label_widget, "visible", FALSE, NULL);
	gtk_label_set_use_underline (self->priv->_label_widget, TRUE);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) self->priv->_label_widget);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) self->priv->_accel_widget);
	gtk_container_child_set ((GtkContainer*) self, (GtkWidget*) self->priv->_accel_widget, "alignment", PANGO_ALIGN_RIGHT, NULL, NULL);
	gtk_container_child_set ((GtkContainer*) self, (GtkWidget*) self->priv->_accel_widget, "padding", 10, NULL, NULL);
	gtk_container_child_set ((GtkContainer*) self, (GtkWidget*) self->priv->_label_widget, "ellipsized", TRUE, NULL, NULL);
	return self;
}


GnomenuMenuLabel* gnomenu_menu_label_new (void) {
	return gnomenu_menu_label_construct (GNOMENU_TYPE_MENU_LABEL);
}


static gboolean gnomenu_menu_label_real_mnemonic_activate (GtkWidget* base, gboolean arg1) {
	GnomenuMenuLabel * self;
	char* _tmp0;
	self = (GnomenuMenuLabel*) base;
	_tmp0 = NULL;
	g_debug ("label.vala:128: mnemonic_activate %s", _tmp0 = bool_to_string (arg1));
	_tmp0 = (g_free (_tmp0), NULL);
	return gtk_widget_mnemonic_activate ((GtkWidget*) self->priv->_label_widget, arg1);
}


static gboolean __lambda0 (GtkWidget* obj, gboolean arg1, GnomenuMenuLabel* self) {
	GtkWidget* _tmp0;
	g_return_val_if_fail (obj != NULL, FALSE);
	_tmp0 = NULL;
	g_debug ("label.vala:143: mnemonic activate: %s", gtk_label_get_label ((_tmp0 = obj, GTK_IS_LABEL (_tmp0) ? ((GtkLabel*) _tmp0) : NULL)));
}


static gboolean ___lambda0_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self) {
	return __lambda0 (_sender, group_cycling, self);
}


static void gnomenu_menu_label_real_add (GtkContainer* base, GtkWidget* child) {
	GnomenuMenuLabel * self;
	GtkWidget* _tmp0;
	GtkWidget* _tmp1;
	self = (GnomenuMenuLabel*) base;
	g_return_if_fail (child != NULL);
	if (!GTK_IS_LABEL (child)) {
		g_warning ("label.vala:139: only GtkLabel is accepted");
		return;
	}
	g_signal_connect (child, "mnemonic-activate", (GCallback) ___lambda0_gtk_widget_mnemonic_activate, self);
	_tmp0 = NULL;
	self->priv->children = g_list_append (self->priv->children, (_tmp0 = child, GTK_IS_LABEL (_tmp0) ? ((GtkLabel*) _tmp0) : NULL));
	gtk_widget_set_parent (child, (GtkWidget*) self);
	g_hash_table_insert (self->priv->props, child, (GnomenuMenuLabelChildPropBag*) g_malloc0 (sizeof (GnomenuMenuLabelChildPropBag)));
	_tmp1 = NULL;
	gnomenu_menu_label_update_label_gravity (self, (_tmp1 = child, GTK_IS_LABEL (_tmp1) ? ((GtkLabel*) _tmp1) : NULL));
}


static void gnomenu_menu_label_real_remove (GtkContainer* base, GtkWidget* child) {
	GnomenuMenuLabel * self;
	GtkWidget* _tmp0;
	self = (GnomenuMenuLabel*) base;
	g_return_if_fail (child != NULL);
	_tmp0 = NULL;
	self->priv->children = g_list_remove_all (self->priv->children, (_tmp0 = child, GTK_IS_LABEL (_tmp0) ? ((GtkLabel*) _tmp0) : NULL));
	gtk_widget_unparent (child);
	g_hash_table_remove (self->priv->props, child);
}


static void gnomenu_menu_label_real_style_set (GtkWidget* base, GtkStyle* old_style) {
	GnomenuMenuLabel * self;
	self = (GnomenuMenuLabel*) base;
	{
		GList* child_collection;
		GList* child_it;
		child_collection = self->priv->children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkLabel* child;
			child = (GtkLabel*) child_it->data;
			{
				gtk_widget_set_style ((GtkWidget*) child, gtk_widget_get_style ((GtkWidget*) self));
			}
		}
	}
}


static void gnomenu_menu_label_real_forall (GtkContainer* base, gboolean include_internals, GtkCallback callback, void* callback_target) {
	GnomenuMenuLabel * self;
	GList* iter;
	self = (GnomenuMenuLabel*) base;
	if (include_internals) {
	}
	iter = self->priv->children;
	while (iter != NULL) {
		GtkWidget* child;
		child = (GtkWidget*) ((GtkLabel*) iter->data);
		iter = iter->next;
		callback (child, callback_target);
	}
}


static void gnomenu_menu_label_real_size_request (GtkWidget* base, GtkRequisition* r) {
	GnomenuMenuLabel * self;
	GtkRequisition cr = {0};
	self = (GnomenuMenuLabel*) base;
	(*r).width = 0;
	(*r).height = 0;
	{
		GList* child_collection;
		GList* child_it;
		child_collection = self->priv->children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp3;
			GtkWidget* child;
			_tmp3 = NULL;
			child = (_tmp3 = (GtkWidget*) ((GtkLabel*) child_it->data), (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3));
			{
				gboolean _tmp0;
				gint padding;
				gtk_widget_size_request (child, &cr);
				if (!(g_object_get (child, "visible", &_tmp0, NULL), _tmp0)) {
					(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
					continue;
				}
				padding = 0;
				gtk_container_child_get ((GtkContainer*) self, child, "padding", &padding, NULL, NULL);
				switch (gnomenu_menu_label_get_gravity (self)) {
					case GNOMENU_GRAVITY_LEFT:
					case GNOMENU_GRAVITY_RIGHT:
					{
						gint _tmp1;
						_tmp1 = 0;
						if ((*r).width > cr.width) {
							_tmp1 = (*r).width;
						} else {
							_tmp1 = cr.width;
						}
						(*r).width = _tmp1;
						(*r).height = (*r).height + (cr.height + padding);
						break;
					}
					case GNOMENU_GRAVITY_UP:
					case GNOMENU_GRAVITY_DOWN:
					{
						gint _tmp2;
						_tmp2 = 0;
						if ((*r).height > cr.height) {
							_tmp2 = (*r).height;
						} else {
							_tmp2 = cr.height;
						}
						(*r).height = _tmp2;
						(*r).width = (*r).width + (cr.width + padding);
						break;
					}
				}
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	}
}


static void gnomenu_menu_label_real_size_allocate (GtkWidget* base, const GdkRectangle* a) {
	GnomenuMenuLabel * self;
	GtkRequisition cr = {0};
	GdkRectangle ca = {0, 0, 0, 0};
	gint x;
	gint y;
	gint num_vis;
	gint expand;
	gint remains;
	self = (GnomenuMenuLabel*) base;
	((GtkWidget*) self)->allocation = (GtkAllocation) (*a);
	x = (*a).x;
	y = (*a).y;
	num_vis = 0;
	expand = 0;
	remains = 0;
	{
		GList* child_collection;
		GList* child_it;
		child_collection = self->priv->children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp1;
			GtkWidget* child;
			_tmp1 = NULL;
			child = (_tmp1 = (GtkWidget*) ((GtkLabel*) child_it->data), (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
			{
				gboolean _tmp0;
				if (!(g_object_get (child, "visible", &_tmp0, NULL), _tmp0)) {
					(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
					continue;
				}
				num_vis++;
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	}
	switch (gnomenu_menu_label_get_gravity (self)) {
		case GNOMENU_GRAVITY_LEFT:
		case GNOMENU_GRAVITY_RIGHT:
		{
			expand = ((GtkWidget*) self)->allocation.height - ((GtkWidget*) self)->requisition.height;
			remains = ((GtkWidget*) self)->allocation.height;
			break;
		}
		case GNOMENU_GRAVITY_UP:
		case GNOMENU_GRAVITY_DOWN:
		{
			expand = ((GtkWidget*) self)->allocation.width - ((GtkWidget*) self)->requisition.width;
			remains = ((GtkWidget*) self)->allocation.width;
			break;
		}
	}
	if (expand < 0) {
		expand = 0;
	}
	{
		GList* child_collection;
		GList* child_it;
		child_collection = self->priv->children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp3;
			GtkWidget* child;
			_tmp3 = NULL;
			child = (_tmp3 = (GtkWidget*) ((GtkLabel*) child_it->data), (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3));
			{
				gboolean _tmp2;
				gint padding;
				PangoAlignment alignment;
				if (!(g_object_get (child, "visible", &_tmp2, NULL), _tmp2)) {
					(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
					continue;
				}
				gtk_widget_get_child_requisition (child, &cr);
				padding = 0;
				gtk_container_child_get ((GtkContainer*) self, child, "padding", &padding, NULL, NULL);
				alignment = PANGO_ALIGN_LEFT;
				gtk_container_child_get ((GtkContainer*) self, child, "alignment", &alignment, NULL, NULL);
				switch (gnomenu_menu_label_get_gravity (self)) {
					case GNOMENU_GRAVITY_LEFT:
					case GNOMENU_GRAVITY_RIGHT:
					{
						ca.x = x;
						ca.y = y;
						ca.width = (*a).width;
						ca.height = cr.height + (expand / num_vis);
						if (ca.height > remains) {
							ca.height = remains;
						}
						remains = remains - (ca.height + padding);
						if (remains < 1) {
							remains = 1;
						}
						y = y + (ca.height + padding);
						switch (alignment) {
							case PANGO_ALIGN_LEFT:
							{
								break;
							}
							case PANGO_ALIGN_RIGHT:
							{
								ca.y = ca.y + padding;
								break;
							}
							case PANGO_ALIGN_CENTER:
							{
								ca.y = ca.y + (padding / 2);
								break;
							}
						}
						break;
					}
					case GNOMENU_GRAVITY_UP:
					case GNOMENU_GRAVITY_DOWN:
					{
						ca.x = x;
						ca.y = y;
						ca.width = cr.width + (expand / num_vis);
						if (ca.width > remains) {
							ca.width = remains;
						}
						remains = remains - (ca.width + padding);
						if (remains < 1) {
							remains = 1;
						}
						ca.height = (*a).height;
						x = x + (ca.width + padding);
						switch (alignment) {
							case PANGO_ALIGN_LEFT:
							{
								break;
							}
							case PANGO_ALIGN_RIGHT:
							{
								ca.x = ca.x + padding;
								break;
							}
							case PANGO_ALIGN_CENTER:
							{
								ca.x = ca.x + (padding / 2);
								break;
							}
						}
						break;
					}
				}
				gtk_widget_size_allocate (child, &ca);
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	}
}


static void gnomenu_menu_label_real_get_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec) {
	GnomenuMenuLabel * self;
	self = (GnomenuMenuLabel*) base;
	g_return_if_fail (child != NULL);
	g_return_if_fail (pspec != NULL);
	switch (id) {
		case GNOMENU_MENU_LABEL_PROP_ALIGNMENT:
		{
			GnomenuMenuLabelChildPropBag* prop;
			prop = g_hash_table_lookup (self->priv->props, child);
			g_assert (prop != NULL);
			g_value_set_enum (&(*value), (gint) (*prop).alignment);
			break;
		}
		case GNOMENU_MENU_LABEL_PROP_PADDING:
		{
			GnomenuMenuLabelChildPropBag* prop;
			prop = g_hash_table_lookup (self->priv->props, child);
			g_assert (prop != NULL);
			g_value_set_int (&(*value), (*prop).padding);
			break;
		}
		case GNOMENU_MENU_LABEL_PROP_ELLIPSIZED:
		{
			GnomenuMenuLabelChildPropBag* prop;
			prop = g_hash_table_lookup (self->priv->props, child);
			g_assert (prop != NULL);
			g_value_set_boolean (&(*value), (*prop).ellipsized);
			break;
		}
	}
}


static void gnomenu_menu_label_real_set_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec) {
	GnomenuMenuLabel * self;
	self = (GnomenuMenuLabel*) base;
	g_return_if_fail (child != NULL);
	g_return_if_fail (pspec != NULL);
	switch (id) {
		case GNOMENU_MENU_LABEL_PROP_ALIGNMENT:
		{
			PangoAlignment alignment;
			GnomenuMenuLabelChildPropBag* prop;
			alignment = (PangoAlignment) g_value_get_enum (&(*value));
			prop = g_hash_table_lookup (self->priv->props, child);
			g_assert (prop != NULL);
			if ((*prop).alignment != alignment) {
				GtkWidget* _tmp0;
				(*prop).alignment = alignment;
				_tmp0 = NULL;
				gnomenu_menu_label_update_label_gravity (self, (_tmp0 = child, GTK_IS_LABEL (_tmp0) ? ((GtkLabel*) _tmp0) : NULL));
			}
			break;
		}
		case GNOMENU_MENU_LABEL_PROP_PADDING:
		{
			gint padding;
			GnomenuMenuLabelChildPropBag* prop;
			padding = g_value_get_int (&(*value));
			prop = g_hash_table_lookup (self->priv->props, child);
			g_assert (prop != NULL);
			if ((*prop).padding != padding) {
				(*prop).padding = padding;
				gtk_widget_queue_resize ((GtkWidget*) self);
			}
			break;
		}
		case GNOMENU_MENU_LABEL_PROP_ELLIPSIZED:
		{
			gboolean ellipsized;
			GnomenuMenuLabelChildPropBag* prop;
			ellipsized = g_value_get_boolean (&(*value));
			prop = g_hash_table_lookup (self->priv->props, child);
			g_assert (prop != NULL);
			if ((*prop).ellipsized != ellipsized) {
				gboolean _tmp1;
				GtkWidget* _tmp2;
				(*prop).ellipsized = ellipsized;
				_tmp1 = FALSE;
				_tmp2 = NULL;
				if (gtk_label_get_angle ((_tmp2 = child, GTK_IS_LABEL (_tmp2) ? ((GtkLabel*) _tmp2) : NULL)) == 0.0) {
					_tmp1 = ellipsized;
				} else {
					_tmp1 = FALSE;
				}
				if (_tmp1) {
					GtkWidget* _tmp3;
					_tmp3 = NULL;
					gtk_label_set_ellipsize ((_tmp3 = child, GTK_IS_LABEL (_tmp3) ? ((GtkLabel*) _tmp3) : NULL), PANGO_ELLIPSIZE_END);
				} else {
					GtkWidget* _tmp4;
					_tmp4 = NULL;
					gtk_label_set_ellipsize ((_tmp4 = child, GTK_IS_LABEL (_tmp4) ? ((GtkLabel*) _tmp4) : NULL), PANGO_ELLIPSIZE_NONE);
				}
				gtk_widget_queue_resize ((GtkWidget*) self);
			}
			break;
		}
	}
}


static void gnomenu_menu_label_update_label_gravity (GnomenuMenuLabel* self, GtkLabel* child) {
	double text_angle;
	PangoAlignment alignment;
	gboolean ellipsized;
	double al;
	gboolean _tmp0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (child != NULL);
	text_angle = gnomenu_gravity_to_text_angle (gnomenu_menu_label_get_gravity (self));
	alignment = PANGO_ALIGN_LEFT;
	ellipsized = FALSE;
	gtk_container_child_get ((GtkContainer*) self, (GtkWidget*) child, "alignment", &alignment, NULL, NULL);
	gtk_container_child_get ((GtkContainer*) self, (GtkWidget*) child, "ellipsized", &ellipsized, NULL, NULL);
	al = 0.0;
	switch (alignment) {
		case PANGO_ALIGN_LEFT:
		{
			al = 0.0;
			break;
		}
		case PANGO_ALIGN_CENTER:
		{
			al = 0.5;
			break;
		}
		case PANGO_ALIGN_RIGHT:
		{
			al = 1.0;
			break;
		}
	}
	switch (self->priv->_gravity) {
		case GNOMENU_GRAVITY_DOWN:
		case GNOMENU_GRAVITY_UP:
		{
			gtk_misc_set_alignment ((GtkMisc*) child, (float) al, (float) 0.5);
			break;
		}
		case GNOMENU_GRAVITY_LEFT:
		case GNOMENU_GRAVITY_RIGHT:
		{
			gtk_misc_set_alignment ((GtkMisc*) child, (float) 0.5, (float) al);
			break;
		}
	}
	gtk_label_set_angle (child, text_angle);
	_tmp0 = FALSE;
	if (text_angle == 0.0) {
		_tmp0 = ellipsized;
	} else {
		_tmp0 = FALSE;
	}
	if (_tmp0) {
		gtk_label_set_ellipsize (child, PANGO_ELLIPSIZE_END);
	} else {
		gtk_label_set_ellipsize (child, PANGO_ELLIPSIZE_NONE);
	}
}


const char* gnomenu_menu_label_get_accel (GnomenuMenuLabel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_accel;
}


void gnomenu_menu_label_set_accel (GnomenuMenuLabel* self, const char* value) {
	char* _tmp2;
	const char* _tmp1;
	g_return_if_fail (self != NULL);
	if (_vala_strcmp0 (self->priv->_accel, value) == 0) {
		return;
	}
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_accel = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), self->priv->_accel = (g_free (self->priv->_accel), NULL), _tmp2);
	if (value == NULL) {
		g_object_set ((GtkWidget*) self->priv->_accel_widget, "visible", FALSE, NULL);
	} else {
		gtk_label_set_label (self->priv->_accel_widget, value);
		g_object_set ((GtkWidget*) self->priv->_accel_widget, "visible", TRUE, NULL);
	}
	gtk_widget_queue_resize ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "accel");
}


gboolean gnomenu_menu_label_get_use_underline (GnomenuMenuLabel* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return self->priv->_use_underline;
}


void gnomenu_menu_label_set_use_underline (GnomenuMenuLabel* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_use_underline == value) {
		return;
	}
	self->priv->_use_underline = value;
	gtk_label_set_use_underline (self->priv->_label_widget, self->priv->_use_underline);
	g_object_notify ((GObject *) self, "use-underline");
}


gint gnomenu_menu_label_get_max_width_chars (GnomenuMenuLabel* self) {
	g_return_val_if_fail (self != NULL, 0);
	return gtk_label_get_max_width_chars (self->priv->_label_widget);
}


void gnomenu_menu_label_set_max_width_chars (GnomenuMenuLabel* self, gint value) {
	g_return_if_fail (self != NULL);
	gtk_label_set_max_width_chars (self->priv->_label_widget, value);
	g_object_notify ((GObject *) self, "max-width-chars");
}


const char* gnomenu_menu_label_get_label (GnomenuMenuLabel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_label;
}


void gnomenu_menu_label_set_label (GnomenuMenuLabel* self, const char* value) {
	char* _tmp2;
	const char* _tmp1;
	g_return_if_fail (self != NULL);
	if (_vala_strcmp0 (self->priv->_label, value) == 0) {
		return;
	}
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_label = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), self->priv->_label = (g_free (self->priv->_label), NULL), _tmp2);
	if (value == NULL) {
		g_object_set ((GtkWidget*) self->priv->_label_widget, "visible", FALSE, NULL);
	} else {
		gtk_label_set_text_with_mnemonic (self->priv->_label_widget, value);
		g_object_set ((GtkWidget*) self->priv->_label_widget, "visible", TRUE, NULL);
	}
	gtk_widget_queue_resize ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "label");
}


GnomenuGravity gnomenu_menu_label_get_gravity (GnomenuMenuLabel* self) {
	g_return_val_if_fail (self != NULL, 0);
	return self->priv->_gravity;
}


void gnomenu_menu_label_set_gravity (GnomenuMenuLabel* self, GnomenuGravity value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_gravity == value) {
		return;
	}
	self->priv->_gravity = value;
	{
		GList* child_collection;
		GList* child_it;
		child_collection = self->priv->children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkLabel* _tmp1;
			GtkLabel* child;
			_tmp1 = NULL;
			child = (_tmp1 = (GtkLabel*) child_it->data, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
			{
				gnomenu_menu_label_update_label_gravity (self, child);
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	}
	gtk_widget_queue_resize ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "gravity");
}


GtkLabel* gnomenu_menu_label_get_label_widget (GnomenuMenuLabel* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_label_widget;
}


guint gnomenu_menu_label_get_mnemonic_keyval (GnomenuMenuLabel* self) {
	g_return_val_if_fail (self != NULL, 0U);
	return gtk_label_get_mnemonic_keyval (self->priv->_label_widget);
}


static void _g_free_gdestroy_notify (void* data) {
	g_free (data);
}


static GObject * gnomenu_menu_label_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GnomenuMenuLabelClass * klass;
	GObjectClass * parent_class;
	GnomenuMenuLabel * self;
	klass = GNOMENU_MENU_LABEL_CLASS (g_type_class_peek (GNOMENU_TYPE_MENU_LABEL));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GNOMENU_MENU_LABEL (obj);
	{
		GHashTable* _tmp0;
		_tmp0 = NULL;
		self->priv->props = (_tmp0 = g_hash_table_new_full (g_direct_hash, g_direct_equal, NULL, _g_free_gdestroy_notify), (self->priv->props == NULL) ? NULL : (self->priv->props = (g_hash_table_unref (self->priv->props), NULL)), _tmp0);
		GTK_WIDGET_SET_FLAGS ((GtkWidget*) self, GTK_NO_WINDOW);
	}
	return obj;
}


static GnomenuMenuLabelChildPropBag* gnomenu_menu_label_child_prop_bag_dup (const GnomenuMenuLabelChildPropBag* self) {
	GnomenuMenuLabelChildPropBag* dup;
	dup = g_new0 (GnomenuMenuLabelChildPropBag, 1);
	memcpy (dup, self, sizeof (GnomenuMenuLabelChildPropBag));
	return dup;
}


static void gnomenu_menu_label_child_prop_bag_free (GnomenuMenuLabelChildPropBag* self) {
	g_free (self);
}


static GType gnomenu_menu_label_child_prop_bag_get_type (void) {
	static GType gnomenu_menu_label_child_prop_bag_type_id = 0;
	if (gnomenu_menu_label_child_prop_bag_type_id == 0) {
		gnomenu_menu_label_child_prop_bag_type_id = g_boxed_type_register_static ("GnomenuMenuLabelChildPropBag", (GBoxedCopyFunc) gnomenu_menu_label_child_prop_bag_dup, (GBoxedFreeFunc) gnomenu_menu_label_child_prop_bag_free);
	}
	return gnomenu_menu_label_child_prop_bag_type_id;
}


static void gnomenu_menu_label_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GnomenuMenuLabel * self;
	gpointer boxed;
	self = GNOMENU_MENU_LABEL (object);
	switch (property_id) {
		case GNOMENU_MENU_LABEL_ACCEL:
		g_value_set_string (value, gnomenu_menu_label_get_accel (self));
		break;
		case GNOMENU_MENU_LABEL_USE_UNDERLINE:
		g_value_set_boolean (value, gnomenu_menu_label_get_use_underline (self));
		break;
		case GNOMENU_MENU_LABEL_MAX_WIDTH_CHARS:
		g_value_set_int (value, gnomenu_menu_label_get_max_width_chars (self));
		break;
		case GNOMENU_MENU_LABEL_LABEL:
		g_value_set_string (value, gnomenu_menu_label_get_label (self));
		break;
		case GNOMENU_MENU_LABEL_GRAVITY:
		g_value_set_enum (value, gnomenu_menu_label_get_gravity (self));
		break;
		case GNOMENU_MENU_LABEL_LABEL_WIDGET:
		g_value_set_object (value, gnomenu_menu_label_get_label_widget (self));
		break;
		case GNOMENU_MENU_LABEL_MNEMONIC_KEYVAL:
		g_value_set_uint (value, gnomenu_menu_label_get_mnemonic_keyval (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gnomenu_menu_label_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GnomenuMenuLabel * self;
	self = GNOMENU_MENU_LABEL (object);
	switch (property_id) {
		case GNOMENU_MENU_LABEL_ACCEL:
		gnomenu_menu_label_set_accel (self, g_value_get_string (value));
		break;
		case GNOMENU_MENU_LABEL_USE_UNDERLINE:
		gnomenu_menu_label_set_use_underline (self, g_value_get_boolean (value));
		break;
		case GNOMENU_MENU_LABEL_MAX_WIDTH_CHARS:
		gnomenu_menu_label_set_max_width_chars (self, g_value_get_int (value));
		break;
		case GNOMENU_MENU_LABEL_LABEL:
		gnomenu_menu_label_set_label (self, g_value_get_string (value));
		break;
		case GNOMENU_MENU_LABEL_GRAVITY:
		gnomenu_menu_label_set_gravity (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gnomenu_menu_label_class_init (GnomenuMenuLabelClass * klass) {
	gnomenu_menu_label_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomenuMenuLabelPrivate));
	G_OBJECT_CLASS (klass)->get_property = gnomenu_menu_label_get_property;
	G_OBJECT_CLASS (klass)->set_property = gnomenu_menu_label_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnomenu_menu_label_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnomenu_menu_label_finalize;
	GTK_WIDGET_CLASS (klass)->mnemonic_activate = gnomenu_menu_label_real_mnemonic_activate;
	GTK_CONTAINER_CLASS (klass)->add = gnomenu_menu_label_real_add;
	GTK_CONTAINER_CLASS (klass)->remove = gnomenu_menu_label_real_remove;
	GTK_WIDGET_CLASS (klass)->style_set = gnomenu_menu_label_real_style_set;
	GTK_CONTAINER_CLASS (klass)->forall = gnomenu_menu_label_real_forall;
	GTK_WIDGET_CLASS (klass)->size_request = gnomenu_menu_label_real_size_request;
	GTK_WIDGET_CLASS (klass)->size_allocate = gnomenu_menu_label_real_size_allocate;
	GTK_CONTAINER_CLASS (klass)->get_child_property = gnomenu_menu_label_real_get_child_property;
	GTK_CONTAINER_CLASS (klass)->set_child_property = gnomenu_menu_label_real_set_child_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LABEL_ACCEL, g_param_spec_string ("accel", "accel", "accel", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LABEL_USE_UNDERLINE, g_param_spec_boolean ("use-underline", "use-underline", "use-underline", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LABEL_MAX_WIDTH_CHARS, g_param_spec_int ("max-width-chars", "max-width-chars", "max-width-chars", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LABEL_LABEL, g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LABEL_GRAVITY, g_param_spec_enum ("gravity", "gravity", "gravity", GNOMENU_TYPE_GRAVITY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LABEL_LABEL_WIDGET, g_param_spec_object ("label-widget", "label-widget", "label-widget", GTK_TYPE_LABEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_LABEL_MNEMONIC_KEYVAL, g_param_spec_uint ("mnemonic-keyval", "mnemonic-keyval", "mnemonic-keyval", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	{
		GParamSpecEnum* _tmp1;
		GParamSpecInt* _tmp2;
		GParamSpecBoolean* _tmp3;
		_tmp1 = NULL;
		gtk_container_class_install_child_property (GTK_CONTAINER_CLASS (klass), (guint) GNOMENU_MENU_LABEL_PROP_ALIGNMENT, (GParamSpec*) (_tmp1 = g_param_spec_enum ("alignment", "Alignment", "the alignment of the child", PANGO_TYPE_ALIGNMENT, (gint) PANGO_ALIGN_CENTER, G_PARAM_READABLE | G_PARAM_WRITABLE)));
		(_tmp1 == NULL) ? NULL : (_tmp1 = (g_param_spec_unref (_tmp1), NULL));
		_tmp2 = NULL;
		gtk_container_class_install_child_property (GTK_CONTAINER_CLASS (klass), (guint) GNOMENU_MENU_LABEL_PROP_PADDING, (GParamSpec*) (_tmp2 = g_param_spec_int ("padding", "Padding", "the padding on left, both or right", 0, 1000, 0, G_PARAM_READABLE | G_PARAM_WRITABLE)));
		(_tmp2 == NULL) ? NULL : (_tmp2 = (g_param_spec_unref (_tmp2), NULL));
		_tmp3 = NULL;
		gtk_container_class_install_child_property (GTK_CONTAINER_CLASS (klass), (guint) GNOMENU_MENU_LABEL_PROP_ELLIPSIZED, (GParamSpec*) (_tmp3 = g_param_spec_boolean ("ellipsized", "Ellipsized", "if the child is ellipsized", FALSE, G_PARAM_READABLE | G_PARAM_WRITABLE)));
		(_tmp3 == NULL) ? NULL : (_tmp3 = (g_param_spec_unref (_tmp3), NULL));
	}
}


static void gnomenu_menu_label_instance_init (GnomenuMenuLabel * self) {
	self->priv = GNOMENU_MENU_LABEL_GET_PRIVATE (self);
	self->priv->_label_widget = g_object_ref_sink ((GtkLabel*) gtk_label_new (""));
	self->priv->_accel_widget = g_object_ref_sink ((GtkLabel*) gtk_label_new (""));
}


static void gnomenu_menu_label_finalize (GObject* obj) {
	GnomenuMenuLabel * self;
	self = GNOMENU_MENU_LABEL (obj);
	(self->priv->_label_widget == NULL) ? NULL : (self->priv->_label_widget = (g_object_unref (self->priv->_label_widget), NULL));
	(self->priv->_accel_widget == NULL) ? NULL : (self->priv->_accel_widget = (g_object_unref (self->priv->_accel_widget), NULL));
	self->priv->_label = (g_free (self->priv->_label), NULL);
	self->priv->_accel = (g_free (self->priv->_accel), NULL);
	(self->priv->children == NULL) ? NULL : (self->priv->children = (g_list_free (self->priv->children), NULL));
	(self->priv->props == NULL) ? NULL : (self->priv->props = (g_hash_table_unref (self->priv->props), NULL));
	G_OBJECT_CLASS (gnomenu_menu_label_parent_class)->finalize (obj);
}


GType gnomenu_menu_label_get_type (void) {
	static GType gnomenu_menu_label_type_id = 0;
	if (gnomenu_menu_label_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuMenuLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_menu_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuMenuLabel), 0, (GInstanceInitFunc) gnomenu_menu_label_instance_init, NULL };
		gnomenu_menu_label_type_id = g_type_register_static (GTK_TYPE_CONTAINER, "GnomenuMenuLabel", &g_define_type_info, 0);
	}
	return gnomenu_menu_label_type_id;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




