
#include <libgnomenu/menubarbox.h>
#include <stdlib.h>
#include <string.h>

typedef struct _GnomenuMenuBarBoxChildPropBag GnomenuMenuBarBoxChildPropBag;

#define GNOMENU_MENU_BAR_BOX_TYPE_CHILD_PROP_BAG (gnomenu_menu_bar_box_child_prop_bag_get_type ())

struct _GnomenuMenuBarBoxChildPropBag {
	gboolean expand;
};



struct _GnomenuMenuBarBoxPrivate {
	GHashTable* props;
	GtkPackDirection _pack_direction;
	GtkPackDirection _child_pack_direction;
	GnomenuGravity _gravity;
	GList* children;
};

#define GNOMENU_MENU_BAR_BOX_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_MENU_BAR_BOX, GnomenuMenuBarBoxPrivate))
enum  {
	GNOMENU_MENU_BAR_BOX_DUMMY_PROPERTY,
	GNOMENU_MENU_BAR_BOX_PACK_DIRECTION,
	GNOMENU_MENU_BAR_BOX_CHILD_PACK_DIRECTION,
	GNOMENU_MENU_BAR_BOX_GRAVITY,
	GNOMENU_MENU_BAR_BOX_BACKGROUND
};
#define GNOMENU_MENU_BAR_BOX_PROP_EXPAND 1234
static void gnomenu_menu_bar_box_real_forall (GtkContainer* base, gboolean include_internals, GtkCallback callback, void* callback_target);
static void gnomenu_menu_bar_box_real_add (GtkContainer* base, GtkWidget* child);
static void gnomenu_menu_bar_box_real_remove (GtkContainer* base, GtkWidget* child);
static void gnomenu_menu_bar_box_real_size_request (GtkWidget* base, GtkRequisition* r);
static void gnomenu_menu_bar_box_real_map (GtkWidget* base);
static void gnomenu_menu_bar_box_real_size_allocate (GtkWidget* base, const GdkRectangle* a);
static void gnomenu_menu_bar_box_real_get_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec);
static void gnomenu_menu_bar_box_real_set_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec);
static void _g_free_gdestroy_notify (void* data);
static GObject * gnomenu_menu_bar_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static GnomenuMenuBarBoxChildPropBag* gnomenu_menu_bar_box_child_prop_bag_dup (const GnomenuMenuBarBoxChildPropBag* self);
static void gnomenu_menu_bar_box_child_prop_bag_free (GnomenuMenuBarBoxChildPropBag* self);
static GType gnomenu_menu_bar_box_child_prop_bag_get_type (void);
static gpointer gnomenu_menu_bar_box_parent_class = NULL;
static void gnomenu_menu_bar_box_finalize (GObject* obj);



GnomenuMenuBarBox* gnomenu_menu_bar_box_construct (GType object_type) {
	GnomenuMenuBarBox * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


GnomenuMenuBarBox* gnomenu_menu_bar_box_new (void) {
	return gnomenu_menu_bar_box_construct (GNOMENU_TYPE_MENU_BAR_BOX);
}


static void gnomenu_menu_bar_box_real_forall (GtkContainer* base, gboolean include_internals, GtkCallback callback, void* callback_target) {
	GnomenuMenuBarBox * self;
	GList* iter;
	self = (GnomenuMenuBarBox*) base;
	if (include_internals) {
	}
	iter = self->priv->children;
	while (iter != NULL) {
		GtkWidget* child;
		child = (GtkWidget*) ((GnomenuMenuBar*) iter->data);
		iter = iter->next;
		callback (child, callback_target);
	}
}


static void gnomenu_menu_bar_box_real_add (GtkContainer* base, GtkWidget* child) {
	GnomenuMenuBarBox * self;
	self = (GnomenuMenuBarBox*) base;
	g_return_if_fail (child != NULL);
	if (GNOMENU_IS_MENU_BAR (child)) {
		GtkWidget* _tmp0;
		GtkWidget* _tmp1;
		GtkWidget* _tmp2;
		_tmp0 = NULL;
		self->priv->children = g_list_append (self->priv->children, (_tmp0 = child, GNOMENU_IS_MENU_BAR (_tmp0) ? ((GnomenuMenuBar*) _tmp0) : NULL));
		gtk_widget_set_parent (child, (GtkWidget*) self);
		g_hash_table_insert (self->priv->props, child, (GnomenuMenuBarBoxChildPropBag*) g_malloc0 (sizeof (GnomenuMenuBarBoxChildPropBag)));
		_tmp1 = NULL;
		gtk_menu_bar_set_pack_direction ((GtkMenuBar*) (_tmp1 = child, GNOMENU_IS_MENU_BAR (_tmp1) ? ((GnomenuMenuBar*) _tmp1) : NULL), gnomenu_menu_bar_box_get_pack_direction (self));
		_tmp2 = NULL;
		gnomenu_menu_bar_set_gravity ((_tmp2 = child, GNOMENU_IS_MENU_BAR (_tmp2) ? ((GnomenuMenuBar*) _tmp2) : NULL), gnomenu_menu_bar_box_get_gravity (self));
	}
}


static void gnomenu_menu_bar_box_real_remove (GtkContainer* base, GtkWidget* child) {
	GnomenuMenuBarBox * self;
	self = (GnomenuMenuBarBox*) base;
	g_return_if_fail (child != NULL);
	if (GNOMENU_IS_MENU_BAR (child)) {
		GtkWidget* _tmp0;
		_tmp0 = NULL;
		self->priv->children = g_list_remove_all (self->priv->children, (_tmp0 = child, GNOMENU_IS_MENU_BAR (_tmp0) ? ((GnomenuMenuBar*) _tmp0) : NULL));
		gtk_widget_unparent (child);
		g_hash_table_remove (self->priv->props, child);
	}
}


static void gnomenu_menu_bar_box_real_size_request (GtkWidget* base, GtkRequisition* r) {
	GnomenuMenuBarBox * self;
	GtkRequisition cr = {0};
	self = (GnomenuMenuBarBox*) base;
	(*r).width = 0;
	(*r).height = 0;
	{
		GList* menubar_collection;
		GList* menubar_it;
		menubar_collection = self->priv->children;
		for (menubar_it = menubar_collection; menubar_it != NULL; menubar_it = menubar_it->next) {
			GnomenuMenuBar* _tmp3;
			GnomenuMenuBar* menubar;
			_tmp3 = NULL;
			menubar = (_tmp3 = (GnomenuMenuBar*) menubar_it->data, (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3));
			{
				gboolean _tmp0;
				if (!(g_object_get ((GtkWidget*) menubar, "visible", &_tmp0, NULL), _tmp0)) {
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
					continue;
				}
				gtk_widget_size_request ((GtkWidget*) menubar, &cr);
				switch (gnomenu_menu_bar_box_get_pack_direction (self)) {
					case GTK_PACK_DIRECTION_LTR:
					case GTK_PACK_DIRECTION_RTL:
					{
						gint _tmp1;
						_tmp1 = 0;
						if ((*r).height > cr.height) {
							_tmp1 = (*r).height;
						} else {
							_tmp1 = cr.height;
						}
						(*r).height = _tmp1;
						(*r).width = (*r).width + cr.width;
						break;
					}
					case GTK_PACK_DIRECTION_BTT:
					case GTK_PACK_DIRECTION_TTB:
					{
						gint _tmp2;
						_tmp2 = 0;
						if ((*r).width > cr.width) {
							_tmp2 = (*r).width;
						} else {
							_tmp2 = cr.width;
						}
						(*r).width = _tmp2;
						(*r).height = (*r).height + cr.height;
						break;
					}
				}
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
}


static void gnomenu_menu_bar_box_real_map (GtkWidget* base) {
	GnomenuMenuBarBox * self;
	self = (GnomenuMenuBarBox*) base;
	GTK_WIDGET_CLASS (gnomenu_menu_bar_box_parent_class)->map ((GtkWidget*) GTK_CONTAINER (self));
}


static void gnomenu_menu_bar_box_real_size_allocate (GtkWidget* base, const GdkRectangle* a) {
	GnomenuMenuBarBox * self;
	GtkRequisition cr = {0};
	GtkAllocation ca = {0, 0, 0, 0};
	gint x;
	gint y;
	gint rev_x;
	gint rev_y;
	gint num_of_expands;
	gint non_expand_a;
	self = (GnomenuMenuBarBox*) base;
	((GtkWidget*) self)->allocation = (GtkAllocation) (*a);
	x = 0;
	y = 0;
	rev_x = (*a).width;
	rev_y = (*a).height;
	num_of_expands = 0;
	non_expand_a = 0;
	{
		GList* menubar_collection;
		GList* menubar_it;
		menubar_collection = self->priv->children;
		for (menubar_it = menubar_collection; menubar_it != NULL; menubar_it = menubar_it->next) {
			GnomenuMenuBar* _tmp1;
			GnomenuMenuBar* menubar;
			_tmp1 = NULL;
			menubar = (_tmp1 = (GnomenuMenuBar*) menubar_it->data, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
			{
				gboolean _tmp0;
				gboolean expand;
				if (!(g_object_get ((GtkWidget*) menubar, "visible", &_tmp0, NULL), _tmp0)) {
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
					continue;
				}
				expand = FALSE;
				gtk_container_child_get ((GtkContainer*) self, (GtkWidget*) menubar, "expand", &expand, NULL, NULL);
				if (expand) {
					num_of_expands++;
				} else {
					gtk_widget_get_child_requisition ((GtkWidget*) menubar, &cr);
					switch (gnomenu_menu_bar_box_get_pack_direction (self)) {
						case GTK_PACK_DIRECTION_LTR:
						case GTK_PACK_DIRECTION_RTL:
						{
							non_expand_a = non_expand_a + cr.width;
							break;
						}
						case GTK_PACK_DIRECTION_BTT:
						case GTK_PACK_DIRECTION_TTB:
						{
							non_expand_a = non_expand_a + cr.height;
							break;
						}
					}
				}
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	{
		GList* menubar_collection;
		GList* menubar_it;
		menubar_collection = self->priv->children;
		for (menubar_it = menubar_collection; menubar_it != NULL; menubar_it = menubar_it->next) {
			GnomenuMenuBar* _tmp4;
			GnomenuMenuBar* menubar;
			_tmp4 = NULL;
			menubar = (_tmp4 = (GnomenuMenuBar*) menubar_it->data, (_tmp4 == NULL) ? NULL : g_object_ref (_tmp4));
			{
				gboolean expand;
				gboolean _tmp2;
				GdkRectangle _tmp3 = {0};
				expand = FALSE;
				if (!(g_object_get ((GtkWidget*) menubar, "visible", &_tmp2, NULL), _tmp2)) {
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
					continue;
				}
				gtk_widget_get_child_requisition ((GtkWidget*) menubar, &cr);
				gtk_container_child_get ((GtkContainer*) self, (GtkWidget*) menubar, "expand", &expand, NULL, NULL);
				switch (gnomenu_menu_bar_box_get_pack_direction (self)) {
					case GTK_PACK_DIRECTION_LTR:
					{
						if (expand) {
							ca.width = ((*a).width - non_expand_a) / num_of_expands;
							if (ca.width < 0) {
								ca.width = 0;
							}
						} else {
							ca.width = cr.width;
						}
						ca.height = (*a).height;
						ca.x = x;
						ca.y = y;
						x = x + ca.width;
						break;
					}
					case GTK_PACK_DIRECTION_RTL:
					{
						if (expand) {
							ca.width = ((*a).width - non_expand_a) / num_of_expands;
							if (ca.width < 0) {
								ca.width = 0;
							}
						} else {
							ca.width = cr.width;
						}
						ca.x = rev_x - ca.width;
						ca.y = y;
						ca.height = (*a).height;
						rev_x = rev_x - ca.width;
						x = x + ca.width;
						break;
					}
					case GTK_PACK_DIRECTION_TTB:
					{
						ca.width = (*a).width;
						if (expand) {
							ca.height = ((*a).height - non_expand_a) / num_of_expands;
							if (ca.height < 0) {
								ca.height = 0;
							}
						} else {
							ca.height = cr.height;
						}
						ca.x = x;
						ca.y = y;
						y = y + ca.height;
						break;
					}
					case GTK_PACK_DIRECTION_BTT:
					{
						ca.width = (*a).width;
						if (expand) {
							ca.height = ((*a).height - non_expand_a) / num_of_expands;
							if (ca.height < 0) {
								ca.height = 0;
							}
						} else {
							ca.height = cr.height;
						}
						ca.x = x;
						ca.y = rev_y - ca.height;
						rev_y = rev_y - ca.height;
						y = y + ca.height;
						break;
					}
				}
				gtk_widget_size_allocate ((GtkWidget*) menubar, (_tmp3 = (GdkRectangle) ca, &_tmp3));
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	GTK_WIDGET_CLASS (gnomenu_menu_bar_box_parent_class)->size_allocate ((GtkWidget*) GTK_CONTAINER (self), &(*a));
}


static void gnomenu_menu_bar_box_real_get_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec) {
	GnomenuMenuBarBox * self;
	self = (GnomenuMenuBarBox*) base;
	g_return_if_fail (child != NULL);
	g_return_if_fail (pspec != NULL);
	switch (id) {
		case GNOMENU_MENU_BAR_BOX_PROP_EXPAND:
		{
			GnomenuMenuBarBoxChildPropBag* prop;
			prop = g_hash_table_lookup (self->priv->props, child);
			g_value_set_boolean (&(*value), (*prop).expand);
			break;
		}
	}
}


static void gnomenu_menu_bar_box_real_set_child_property (GtkContainer* base, GtkWidget* child, guint id, const GValue* value, GParamSpec* pspec) {
	GnomenuMenuBarBox * self;
	self = (GnomenuMenuBarBox*) base;
	g_return_if_fail (child != NULL);
	g_return_if_fail (pspec != NULL);
	switch (id) {
		case GNOMENU_MENU_BAR_BOX_PROP_EXPAND:
		{
			gboolean expand;
			GnomenuMenuBarBoxChildPropBag* prop;
			expand = g_value_get_boolean (&(*value));
			prop = g_hash_table_lookup (self->priv->props, child);
			if ((*prop).expand != expand) {
				(*prop).expand = expand;
				gtk_widget_queue_resize ((GtkWidget*) self);
			}
			break;
		}
	}
}


GtkPackDirection gnomenu_menu_bar_box_get_pack_direction (GnomenuMenuBarBox* self) {
	g_return_val_if_fail (self != NULL, 0);
	/* The child menubar's child pack direction is the same
	 * as this menubox's pack direction,
	 * whilst the child menubar's pack direction is the same
	 * as this menubox's child pack direction.
	 *
	 * This is to provide a sane layout for the vertical left
	 * panel*/
	return self->priv->_pack_direction;
}


void gnomenu_menu_bar_box_set_pack_direction (GnomenuMenuBarBox* self, GtkPackDirection value) {
	g_return_if_fail (self != NULL);
	{
		GList* menubar_collection;
		GList* menubar_it;
		menubar_collection = self->priv->children;
		for (menubar_it = menubar_collection; menubar_it != NULL; menubar_it = menubar_it->next) {
			GnomenuMenuBar* _tmp1;
			GnomenuMenuBar* menubar;
			_tmp1 = NULL;
			menubar = (_tmp1 = (GnomenuMenuBar*) menubar_it->data, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
			{
				gtk_menu_bar_set_child_pack_direction ((GtkMenuBar*) menubar, value);
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	if (self->priv->_pack_direction == value) {
		return;
	}
	self->priv->_pack_direction = value;
	gtk_widget_queue_resize ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "pack-direction");
}


GtkPackDirection gnomenu_menu_bar_box_get_child_pack_direction (GnomenuMenuBarBox* self) {
	g_return_val_if_fail (self != NULL, 0);
	return self->priv->_child_pack_direction;
}


void gnomenu_menu_bar_box_set_child_pack_direction (GnomenuMenuBarBox* self, GtkPackDirection value) {
	g_return_if_fail (self != NULL);
	{
		GList* menubar_collection;
		GList* menubar_it;
		menubar_collection = self->priv->children;
		for (menubar_it = menubar_collection; menubar_it != NULL; menubar_it = menubar_it->next) {
			GnomenuMenuBar* _tmp1;
			GnomenuMenuBar* menubar;
			_tmp1 = NULL;
			menubar = (_tmp1 = (GnomenuMenuBar*) menubar_it->data, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
			{
				gtk_menu_bar_set_pack_direction ((GtkMenuBar*) menubar, value);
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	if (self->priv->_child_pack_direction == value) {
		return;
	}
	self->priv->_child_pack_direction = value;
	gtk_widget_queue_resize ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "child-pack-direction");
}


GnomenuGravity gnomenu_menu_bar_box_get_gravity (GnomenuMenuBarBox* self) {
	g_return_val_if_fail (self != NULL, 0);
	return self->priv->_gravity;
}


void gnomenu_menu_bar_box_set_gravity (GnomenuMenuBarBox* self, GnomenuGravity value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_gravity == value) {
		return;
	}
	self->priv->_gravity = value;
	{
		GList* menubar_collection;
		GList* menubar_it;
		menubar_collection = self->priv->children;
		for (menubar_it = menubar_collection; menubar_it != NULL; menubar_it = menubar_it->next) {
			GnomenuMenuBar* _tmp1;
			GnomenuMenuBar* menubar;
			_tmp1 = NULL;
			menubar = (_tmp1 = (GnomenuMenuBar*) menubar_it->data, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
			{
				gnomenu_menu_bar_set_gravity (menubar, value);
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "gravity");
}


void gnomenu_menu_bar_box_set_background (GnomenuMenuBarBox* self, GnomenuBackground* value) {
	GnomenuBackground* bg;
	g_return_if_fail (self != NULL);
	bg = gnomenu_background_clone (value);
	{
		GList* menubar_collection;
		GList* menubar_it;
		menubar_collection = self->priv->children;
		for (menubar_it = menubar_collection; menubar_it != NULL; menubar_it = menubar_it->next) {
			GnomenuMenuBar* _tmp0;
			GnomenuMenuBar* menubar;
			_tmp0 = NULL;
			menubar = (_tmp0 = (GnomenuMenuBar*) menubar_it->data, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
			{
				bg->offset_x = ((GtkWidget*) menubar)->allocation.x - ((GtkWidget*) self)->allocation.x;
				bg->offset_y = ((GtkWidget*) menubar)->allocation.y - ((GtkWidget*) self)->allocation.y;
				gnomenu_menu_bar_set_background (menubar, bg);
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	(bg == NULL) ? NULL : (bg = (gnomenu_background_unref (bg), NULL));
	g_object_notify ((GObject *) self, "background");
}


static void _g_free_gdestroy_notify (void* data) {
	g_free (data);
}


static GObject * gnomenu_menu_bar_box_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GnomenuMenuBarBoxClass * klass;
	GObjectClass * parent_class;
	GnomenuMenuBarBox * self;
	klass = GNOMENU_MENU_BAR_BOX_CLASS (g_type_class_peek (GNOMENU_TYPE_MENU_BAR_BOX));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GNOMENU_MENU_BAR_BOX (obj);
	{
		GHashTable* _tmp0;
		GTK_WIDGET_SET_FLAGS ((GtkWidget*) self, GTK_NO_WINDOW);
		_tmp0 = NULL;
		self->priv->props = (_tmp0 = g_hash_table_new_full (g_direct_hash, g_direct_equal, NULL, _g_free_gdestroy_notify), (self->priv->props == NULL) ? NULL : (self->priv->props = (g_hash_table_unref (self->priv->props), NULL)), _tmp0);
	}
	return obj;
}


static GnomenuMenuBarBoxChildPropBag* gnomenu_menu_bar_box_child_prop_bag_dup (const GnomenuMenuBarBoxChildPropBag* self) {
	GnomenuMenuBarBoxChildPropBag* dup;
	dup = g_new0 (GnomenuMenuBarBoxChildPropBag, 1);
	memcpy (dup, self, sizeof (GnomenuMenuBarBoxChildPropBag));
	return dup;
}


static void gnomenu_menu_bar_box_child_prop_bag_free (GnomenuMenuBarBoxChildPropBag* self) {
	g_free (self);
}


static GType gnomenu_menu_bar_box_child_prop_bag_get_type (void) {
	static GType gnomenu_menu_bar_box_child_prop_bag_type_id = 0;
	if (gnomenu_menu_bar_box_child_prop_bag_type_id == 0) {
		gnomenu_menu_bar_box_child_prop_bag_type_id = g_boxed_type_register_static ("GnomenuMenuBarBoxChildPropBag", (GBoxedCopyFunc) gnomenu_menu_bar_box_child_prop_bag_dup, (GBoxedFreeFunc) gnomenu_menu_bar_box_child_prop_bag_free);
	}
	return gnomenu_menu_bar_box_child_prop_bag_type_id;
}


static void gnomenu_menu_bar_box_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GnomenuMenuBarBox * self;
	gpointer boxed;
	self = GNOMENU_MENU_BAR_BOX (object);
	switch (property_id) {
		case GNOMENU_MENU_BAR_BOX_PACK_DIRECTION:
		g_value_set_enum (value, gnomenu_menu_bar_box_get_pack_direction (self));
		break;
		case GNOMENU_MENU_BAR_BOX_CHILD_PACK_DIRECTION:
		g_value_set_enum (value, gnomenu_menu_bar_box_get_child_pack_direction (self));
		break;
		case GNOMENU_MENU_BAR_BOX_GRAVITY:
		g_value_set_enum (value, gnomenu_menu_bar_box_get_gravity (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gnomenu_menu_bar_box_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GnomenuMenuBarBox * self;
	self = GNOMENU_MENU_BAR_BOX (object);
	switch (property_id) {
		case GNOMENU_MENU_BAR_BOX_PACK_DIRECTION:
		gnomenu_menu_bar_box_set_pack_direction (self, g_value_get_enum (value));
		break;
		case GNOMENU_MENU_BAR_BOX_CHILD_PACK_DIRECTION:
		gnomenu_menu_bar_box_set_child_pack_direction (self, g_value_get_enum (value));
		break;
		case GNOMENU_MENU_BAR_BOX_GRAVITY:
		gnomenu_menu_bar_box_set_gravity (self, g_value_get_enum (value));
		break;
		case GNOMENU_MENU_BAR_BOX_BACKGROUND:
		gnomenu_menu_bar_box_set_background (self, gnomenu_value_get_background (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gnomenu_menu_bar_box_class_init (GnomenuMenuBarBoxClass * klass) {
	gnomenu_menu_bar_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomenuMenuBarBoxPrivate));
	G_OBJECT_CLASS (klass)->get_property = gnomenu_menu_bar_box_get_property;
	G_OBJECT_CLASS (klass)->set_property = gnomenu_menu_bar_box_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnomenu_menu_bar_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnomenu_menu_bar_box_finalize;
	GTK_CONTAINER_CLASS (klass)->forall = gnomenu_menu_bar_box_real_forall;
	GTK_CONTAINER_CLASS (klass)->add = gnomenu_menu_bar_box_real_add;
	GTK_CONTAINER_CLASS (klass)->remove = gnomenu_menu_bar_box_real_remove;
	GTK_WIDGET_CLASS (klass)->size_request = gnomenu_menu_bar_box_real_size_request;
	GTK_WIDGET_CLASS (klass)->map = gnomenu_menu_bar_box_real_map;
	GTK_WIDGET_CLASS (klass)->size_allocate = gnomenu_menu_bar_box_real_size_allocate;
	GTK_CONTAINER_CLASS (klass)->get_child_property = gnomenu_menu_bar_box_real_get_child_property;
	GTK_CONTAINER_CLASS (klass)->set_child_property = gnomenu_menu_bar_box_real_set_child_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_BOX_PACK_DIRECTION, g_param_spec_enum ("pack-direction", "pack-direction", "pack-direction", GTK_TYPE_PACK_DIRECTION, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_BOX_CHILD_PACK_DIRECTION, g_param_spec_enum ("child-pack-direction", "child-pack-direction", "child-pack-direction", GTK_TYPE_PACK_DIRECTION, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_BOX_GRAVITY, g_param_spec_enum ("gravity", "gravity", "gravity", GNOMENU_TYPE_GRAVITY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOMENU_MENU_BAR_BOX_BACKGROUND, gnomenu_param_spec_background ("background", "background", "background", GNOMENU_TYPE_BACKGROUND, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
	{
		GParamSpecBoolean* _tmp1;
		_tmp1 = NULL;
		gtk_container_class_install_child_property (GTK_CONTAINER_CLASS (klass), (guint) GNOMENU_MENU_BAR_BOX_PROP_EXPAND, (GParamSpec*) (_tmp1 = g_param_spec_boolean ("expand", "Expand", "the child will expand if set to true", FALSE, G_PARAM_READABLE | G_PARAM_WRITABLE)));
		(_tmp1 == NULL) ? NULL : (_tmp1 = (g_param_spec_unref (_tmp1), NULL));
	}
}


static void gnomenu_menu_bar_box_instance_init (GnomenuMenuBarBox * self) {
	self->priv = GNOMENU_MENU_BAR_BOX_GET_PRIVATE (self);
}


static void gnomenu_menu_bar_box_finalize (GObject* obj) {
	GnomenuMenuBarBox * self;
	self = GNOMENU_MENU_BAR_BOX (obj);
	(self->priv->props == NULL) ? NULL : (self->priv->props = (g_hash_table_unref (self->priv->props), NULL));
	(self->priv->children == NULL) ? NULL : (self->priv->children = (g_list_free (self->priv->children), NULL));
	G_OBJECT_CLASS (gnomenu_menu_bar_box_parent_class)->finalize (obj);
}


GType gnomenu_menu_bar_box_get_type (void) {
	static GType gnomenu_menu_bar_box_type_id = 0;
	if (gnomenu_menu_bar_box_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuMenuBarBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_menu_bar_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuMenuBarBox), 0, (GInstanceInitFunc) gnomenu_menu_bar_box_instance_init, NULL };
		gnomenu_menu_bar_box_type_id = g_type_register_static (GTK_TYPE_CONTAINER, "GnomenuMenuBarBox", &g_define_type_info, 0);
	}
	return gnomenu_menu_bar_box_type_id;
}




