
#include <libgnomenu/parser.h>
#include <libgnomenu/interface-item.h>
#include <gobject/gvaluecollector.h>


#define GNOMENU_PARSER_TYPE_STATE (gnomenu_parser_state_get_type ())
#define GNOMENU_PARSER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_PARSER_TYPE_STATE, GnomenuParserState))
#define GNOMENU_PARSER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_PARSER_TYPE_STATE, GnomenuParserStateClass))
#define GNOMENU_PARSER_IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_PARSER_TYPE_STATE))
#define GNOMENU_PARSER_IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_PARSER_TYPE_STATE))
#define GNOMENU_PARSER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_PARSER_TYPE_STATE, GnomenuParserStateClass))

typedef struct _GnomenuParserState GnomenuParserState;
typedef struct _GnomenuParserStateClass GnomenuParserStateClass;
typedef struct _GnomenuParserStatePrivate GnomenuParserStatePrivate;
typedef struct _GnomenuParserParamSpecState GnomenuParserParamSpecState;

struct _GnomenuParserState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnomenuParserStatePrivate * priv;
	GnomenuShell* shell;
	gint position;
	gboolean item_has_sub_shell;
};

struct _GnomenuParserStateClass {
	GTypeClass parent_class;
	void (*finalize) (GnomenuParserState *self);
};

struct _GnomenuParserParamSpecState {
	GParamSpec parent_instance;
};



struct _GnomenuParserPrivate {
	GQueue* stack;
	gboolean is_bootstrapping;
};

#define GNOMENU_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_PARSER, GnomenuParserPrivate))
enum  {
	GNOMENU_PARSER_DUMMY_PROPERTY
};
static void _gnomenu_parser_start_element_gmarkup_parser_start_element_func (GMarkupParseContext* context, const char* element_name, char** attribute_names, char** attribute_values, gpointer self, GError** error);
static void _gnomenu_parser_end_element_gmarkup_parser_end_element_func (GMarkupParseContext* context, const char* element_name, gpointer self, GError** error);
static GnomenuParser* gnomenu_parser_construct (GType object_type, GnomenuShell* shell);
static GnomenuParser* gnomenu_parser_new (GnomenuShell* shell);
static void gnomenu_parser_start_element (GnomenuParser* self, GMarkupParseContext* context, const char* element_name, char** attribute_names, int attribute_names_length1, char** attribute_values, int attribute_values_length1, GError** error);
static void gnomenu_parser_setup_item (GnomenuParser* self, GnomenuItem* item, char** attr_names, int attr_names_length1, char** attr_vals, int attr_vals_length1);
static void gnomenu_parser_end_element (GnomenuParser* self, GMarkupParseContext* context, const char* element_name, GError** error);
static GnomenuParserState* gnomenu_parser_get_state (GnomenuParser* self);
enum  {
	GNOMENU_PARSER_STATE_DUMMY_PROPERTY
};
static GnomenuParserState* gnomenu_parser_state_construct (GType object_type, GnomenuShell* shell);
static GnomenuParserState* gnomenu_parser_state_new (GnomenuShell* shell);
static GnomenuItem* gnomenu_parser_state_get_item (GnomenuParserState* self);
static GParamSpec* gnomenu_parser_param_spec_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
static gpointer gnomenu_parser_value_get_state (const GValue* value);
static void gnomenu_parser_value_set_state (GValue* value, gpointer v_object);
static gpointer gnomenu_parser_state_parent_class = NULL;
static void gnomenu_parser_state_finalize (GnomenuParserState* obj);
static GType gnomenu_parser_state_get_type (void);
static gpointer gnomenu_parser_state_ref (gpointer instance);
static void gnomenu_parser_state_unref (gpointer instance);
static gpointer gnomenu_parser_parent_class = NULL;
static void gnomenu_parser_finalize (GnomenuParser* obj);
static gint _vala_array_length (gpointer array);

static const GMarkupParser GNOMENU_PARSER_parser_functions = {_gnomenu_parser_start_element_gmarkup_parser_start_element_func, _gnomenu_parser_end_element_gmarkup_parser_end_element_func, NULL, NULL, NULL};


static void _gnomenu_parser_start_element_gmarkup_parser_start_element_func (GMarkupParseContext* context, const char* element_name, char** attribute_names, char** attribute_values, gpointer self, GError** error) {
	gnomenu_parser_start_element (self, context, element_name, attribute_names, _vala_array_length (attribute_names), attribute_values, _vala_array_length (attribute_values), error);
}


static void _gnomenu_parser_end_element_gmarkup_parser_end_element_func (GMarkupParseContext* context, const char* element_name, gpointer self, GError** error) {
	gnomenu_parser_end_element (self, context, element_name, error);
}


void gnomenu_parser_parse (GnomenuShell* shell, const char* description, GError** error) {
	GError * inner_error;
	GnomenuParser* parser;
	GTimer* timer;
	GMarkupParseContext* context;
	g_return_if_fail (shell != NULL);
	g_return_if_fail (description != NULL);
	inner_error = NULL;
	parser = gnomenu_parser_new (shell);
	timer = g_timer_new ();
	context = g_markup_parse_context_new (&GNOMENU_PARSER_parser_functions, 0, parser, NULL);
	g_markup_parse_context_parse (context, description, (glong) (-1), &inner_error);
	if (inner_error != NULL) {
		g_propagate_error (error, inner_error);
		(parser == NULL) ? NULL : (parser = (gnomenu_parser_unref (parser), NULL));
		(timer == NULL) ? NULL : (timer = (g_timer_destroy (timer), NULL));
		(context == NULL) ? NULL : (context = (g_markup_parse_context_free (context), NULL));
		return;
	}
	g_debug ("parser.vala:15: Parser consumed: %lf for %ld bytes", g_timer_elapsed (timer, NULL), strlen (description));
	(parser == NULL) ? NULL : (parser = (gnomenu_parser_unref (parser), NULL));
	(timer == NULL) ? NULL : (timer = (g_timer_destroy (timer), NULL));
	(context == NULL) ? NULL : (context = (g_markup_parse_context_free (context), NULL));
}


static GnomenuParser* gnomenu_parser_construct (GType object_type, GnomenuShell* shell) {
	GnomenuParser* self;
	GQueue* _tmp0;
	GnomenuParserState* bootstrap;
	GnomenuParserState* _tmp1;
	g_return_val_if_fail (shell != NULL, NULL);
	self = (GnomenuParser*) g_type_create_instance (object_type);
	_tmp0 = NULL;
	self->priv->stack = (_tmp0 = g_queue_new (), (self->priv->stack == NULL) ? NULL : (self->priv->stack = (g_queue_free (self->priv->stack), NULL)), _tmp0);
	bootstrap = gnomenu_parser_state_new (shell);
	self->priv->is_bootstrapping = TRUE;
	_tmp1 = NULL;
	g_queue_push_tail (self->priv->stack, (_tmp1 = bootstrap, (_tmp1 == NULL) ? NULL : gnomenu_parser_state_ref (_tmp1)));
	(bootstrap == NULL) ? NULL : (bootstrap = (gnomenu_parser_state_unref (bootstrap), NULL));
	return self;
}


static GnomenuParser* gnomenu_parser_new (GnomenuShell* shell) {
	return gnomenu_parser_construct (GNOMENU_TYPE_PARSER, shell);
}


static void gnomenu_parser_start_element (GnomenuParser* self, GMarkupParseContext* context, const char* element_name, char** attribute_names, int attribute_names_length1, char** attribute_values, int attribute_values_length1, GError** error) {
	GError * inner_error;
	GQuark _tmp4;
	char* _tmp3;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (element_name != NULL);
	inner_error = NULL;
	_tmp3 = NULL;
	static GQuark _tmp4_label0 = 0;
	static GQuark _tmp4_label1 = 0;
	_tmp3 = element_name;
	_tmp4 = (NULL == _tmp3) ? 0 : g_quark_from_string (_tmp3);
	if (_tmp4 == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("menu"))))
	do {
		if (!self->priv->is_bootstrapping) {
			GnomenuItem* _tmp0;
			GnomenuItem* _tmp1;
			/*if this is not the root <menu> entry
			 * aka, we are at
			 * <menu><item><MENU>*/
			_tmp0 = NULL;
			gnomenu_item_set_has_sub_shell (_tmp0 = gnomenu_parser_state_get_item (gnomenu_parser_get_state (self)), TRUE);
			(_tmp0 == NULL) ? NULL : (_tmp0 = (g_object_unref (_tmp0), NULL));
			gnomenu_parser_get_state (self)->item_has_sub_shell = TRUE;
			/* nested the menu, change state*/
			_tmp1 = NULL;
			g_queue_push_tail (self->priv->stack, gnomenu_parser_state_new (gnomenu_item_get_sub_shell (_tmp1 = gnomenu_parser_state_get_item (gnomenu_parser_get_state (self)))));
			(_tmp1 == NULL) ? NULL : (_tmp1 = (g_object_unref (_tmp1), NULL));
		}
		break;
	} while (0); else if (_tmp4 == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("item"))))
	do {
		GnomenuItem* _tmp2;
		self->priv->is_bootstrapping = FALSE;
		_tmp2 = NULL;
		gnomenu_parser_setup_item (self, _tmp2 = gnomenu_parser_state_get_item (gnomenu_parser_get_state (self)), attribute_names, attribute_names_length1, attribute_values, attribute_values_length1);
		(_tmp2 == NULL) ? NULL : (_tmp2 = (g_object_unref (_tmp2), NULL));
		gnomenu_parser_get_state (self)->item_has_sub_shell = FALSE;
		break;
	} while (0); else
	do {
		inner_error = g_error_new_literal (G_MARKUP_ERROR, G_MARKUP_ERROR_UNKNOWN_ELEMENT, "unkown element");
		if (inner_error != NULL) {
			if (inner_error->domain == G_MARKUP_ERROR) {
				g_propagate_error (error, inner_error);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
				g_clear_error (&inner_error);
				return;
			}
		}
	} while (0);
}


static void gnomenu_parser_setup_item (GnomenuParser* self, GnomenuItem* item, char** attr_names, int attr_names_length1, char** attr_vals, int attr_vals_length1) {
	const char* label;
	const char* icon;
	const char* type;
	const char* state;
	const char* font;
	const char* id;
	const char* accel;
	gboolean sensitive;
	gboolean visible;
	gboolean underline;
	gboolean client_side;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	label = NULL;
	icon = NULL;
	type = NULL;
	state = NULL;
	font = NULL;
	id = NULL;
	accel = NULL;
	sensitive = TRUE;
	visible = TRUE;
	underline = TRUE;
	client_side = FALSE;
	g_markup_collect_attributes ("item", attr_names, attr_vals, NULL, G_MARKUP_COLLECT_STRING | G_MARKUP_COLLECT_OPTIONAL, "label", &label, G_MARKUP_COLLECT_STRING | G_MARKUP_COLLECT_OPTIONAL, "type", &type, G_MARKUP_COLLECT_STRING | G_MARKUP_COLLECT_OPTIONAL, "state", &state, G_MARKUP_COLLECT_STRING | G_MARKUP_COLLECT_OPTIONAL, "font", &font, G_MARKUP_COLLECT_STRING | G_MARKUP_COLLECT_OPTIONAL, "id", &id, G_MARKUP_COLLECT_STRING | G_MARKUP_COLLECT_OPTIONAL, "icon", &icon, G_MARKUP_COLLECT_STRING | G_MARKUP_COLLECT_OPTIONAL, "accel", &accel, G_MARKUP_COLLECT_TRISTATE, "visible", &visible, G_MARKUP_COLLECT_TRISTATE, "underline", &underline, G_MARKUP_COLLECT_TRISTATE, "sensitive", &sensitive, G_MARKUP_COLLECT_TRISTATE, "client-side", &client_side, G_MARKUP_COLLECT_INVALID, NULL);
	if (visible != FALSE) {
		visible = TRUE;
	}
	if (sensitive != FALSE) {
		sensitive = TRUE;
	}
	if (underline != FALSE) {
		underline = TRUE;
	}
	if (client_side != TRUE) {
		client_side = FALSE;
	}
	gnomenu_item_set_item_id (item, id);
	gnomenu_item_set_item_visible (item, visible);
	gnomenu_item_set_item_use_underline (item, underline);
	gnomenu_item_set_item_sensitive (item, sensitive);
	gnomenu_item_set_item_type (item, gnomenu_item_type_from_string (type));
	gnomenu_item_set_item_accel_text (item, accel);
	gnomenu_item_set_item_label (item, label);
	gnomenu_item_set_item_icon (item, icon);
	gnomenu_item_set_item_state (item, gnomenu_item_state_from_string (state));
	gnomenu_item_set_item_font (item, font);
	gnomenu_item_set_client_side_sub_shell (item, client_side);
}


static void gnomenu_parser_end_element (GnomenuParser* self, GMarkupParseContext* context, const char* element_name, GError** error) {
	GQuark _tmp3;
	char* _tmp2;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (element_name != NULL);
	_tmp2 = NULL;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	_tmp2 = element_name;
	_tmp3 = (NULL == _tmp2) ? 0 : g_quark_from_string (_tmp2);
	if (_tmp3 == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("menu"))))
	do {
		GnomenuParserState* _tmp0;
		gnomenu_shell_set_length (gnomenu_parser_get_state (self)->shell, gnomenu_parser_get_state (self)->position);
		_tmp0 = NULL;
		_tmp0 = (GnomenuParserState*) g_queue_pop_tail (self->priv->stack);
		(_tmp0 == NULL) ? NULL : (_tmp0 = (gnomenu_parser_state_unref (_tmp0), NULL));
		break;
	} while (0); else if (_tmp3 == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("item"))))
	do {
		if (!gnomenu_parser_get_state (self)->item_has_sub_shell) {
			GnomenuItem* _tmp1;
			_tmp1 = NULL;
			gnomenu_item_set_has_sub_shell (_tmp1 = gnomenu_parser_state_get_item (gnomenu_parser_get_state (self)), FALSE);
			(_tmp1 == NULL) ? NULL : (_tmp1 = (g_object_unref (_tmp1), NULL));
		}
		gnomenu_parser_get_state (self)->position++;
		break;
	} while (0);
}


static GnomenuParserState* gnomenu_parser_get_state (GnomenuParser* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return (GnomenuParserState*) g_queue_peek_tail (self->priv->stack);
}


static GnomenuParserState* gnomenu_parser_state_construct (GType object_type, GnomenuShell* shell) {
	GnomenuParserState* self;
	GnomenuShell* _tmp1;
	GnomenuShell* _tmp0;
	g_return_val_if_fail (shell != NULL, NULL);
	self = (GnomenuParserState*) g_type_create_instance (object_type);
	_tmp1 = NULL;
	_tmp0 = NULL;
	self->shell = (_tmp1 = (_tmp0 = shell, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0)), (self->shell == NULL) ? NULL : (self->shell = (g_object_unref (self->shell), NULL)), _tmp1);
	self->item_has_sub_shell = FALSE;
	self->position = 0;
	return self;
}


static GnomenuParserState* gnomenu_parser_state_new (GnomenuShell* shell) {
	return gnomenu_parser_state_construct (GNOMENU_PARSER_TYPE_STATE, shell);
}


static GnomenuItem* gnomenu_parser_state_get_item (GnomenuParserState* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return gnomenu_shell_get_item (self->shell, self->position);
}


static void gnomenu_parser_value_state_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void gnomenu_parser_value_state_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		gnomenu_parser_state_unref (value->data[0].v_pointer);
	}
}


static void gnomenu_parser_value_state_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnomenu_parser_state_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer gnomenu_parser_value_state_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* gnomenu_parser_value_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GnomenuParserState* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnomenu_parser_state_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* gnomenu_parser_value_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GnomenuParserState** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnomenu_parser_state_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* gnomenu_parser_param_spec_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GnomenuParserParamSpecState* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNOMENU_PARSER_TYPE_STATE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer gnomenu_parser_value_get_state (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_PARSER_TYPE_STATE), NULL);
	return value->data[0].v_pointer;
}


static void gnomenu_parser_value_set_state (GValue* value, gpointer v_object) {
	GnomenuParserState* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_PARSER_TYPE_STATE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNOMENU_PARSER_TYPE_STATE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnomenu_parser_state_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnomenu_parser_state_unref (old);
	}
}


static void gnomenu_parser_state_class_init (GnomenuParserStateClass * klass) {
	gnomenu_parser_state_parent_class = g_type_class_peek_parent (klass);
	GNOMENU_PARSER_STATE_CLASS (klass)->finalize = gnomenu_parser_state_finalize;
}


static void gnomenu_parser_state_instance_init (GnomenuParserState * self) {
	self->ref_count = 1;
}


static void gnomenu_parser_state_finalize (GnomenuParserState* obj) {
	GnomenuParserState * self;
	self = GNOMENU_PARSER_STATE (obj);
	(self->shell == NULL) ? NULL : (self->shell = (g_object_unref (self->shell), NULL));
}


static GType gnomenu_parser_state_get_type (void) {
	static GType gnomenu_parser_state_type_id = 0;
	if (gnomenu_parser_state_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { gnomenu_parser_value_state_init, gnomenu_parser_value_state_free_value, gnomenu_parser_value_state_copy_value, gnomenu_parser_value_state_peek_pointer, "p", gnomenu_parser_value_state_collect_value, "p", gnomenu_parser_value_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuParserStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_parser_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuParserState), 0, (GInstanceInitFunc) gnomenu_parser_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		gnomenu_parser_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnomenuParserState", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return gnomenu_parser_state_type_id;
}


static gpointer gnomenu_parser_state_ref (gpointer instance) {
	GnomenuParserState* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void gnomenu_parser_state_unref (gpointer instance) {
	GnomenuParserState* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNOMENU_PARSER_STATE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void gnomenu_value_parser_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void gnomenu_value_parser_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		gnomenu_parser_unref (value->data[0].v_pointer);
	}
}


static void gnomenu_value_parser_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnomenu_parser_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer gnomenu_value_parser_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* gnomenu_value_parser_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GnomenuParser* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnomenu_parser_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* gnomenu_value_parser_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GnomenuParser** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnomenu_parser_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* gnomenu_param_spec_parser (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GnomenuParamSpecParser* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNOMENU_TYPE_PARSER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer gnomenu_value_get_parser (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_TYPE_PARSER), NULL);
	return value->data[0].v_pointer;
}


void gnomenu_value_set_parser (GValue* value, gpointer v_object) {
	GnomenuParser* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNOMENU_TYPE_PARSER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNOMENU_TYPE_PARSER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnomenu_parser_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnomenu_parser_unref (old);
	}
}


static void gnomenu_parser_class_init (GnomenuParserClass * klass) {
	gnomenu_parser_parent_class = g_type_class_peek_parent (klass);
	GNOMENU_PARSER_CLASS (klass)->finalize = gnomenu_parser_finalize;
	g_type_class_add_private (klass, sizeof (GnomenuParserPrivate));
}


static void gnomenu_parser_instance_init (GnomenuParser * self) {
	self->priv = GNOMENU_PARSER_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void gnomenu_parser_finalize (GnomenuParser* obj) {
	GnomenuParser * self;
	self = GNOMENU_PARSER (obj);
	(self->priv->stack == NULL) ? NULL : (self->priv->stack = (g_queue_free (self->priv->stack), NULL));
}


GType gnomenu_parser_get_type (void) {
	static GType gnomenu_parser_type_id = 0;
	if (gnomenu_parser_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { gnomenu_value_parser_init, gnomenu_value_parser_free_value, gnomenu_value_parser_copy_value, gnomenu_value_parser_peek_pointer, "p", gnomenu_value_parser_collect_value, "p", gnomenu_value_parser_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuParser), 0, (GInstanceInitFunc) gnomenu_parser_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		gnomenu_parser_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnomenuParser", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return gnomenu_parser_type_id;
}


gpointer gnomenu_parser_ref (gpointer instance) {
	GnomenuParser* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void gnomenu_parser_unref (gpointer instance) {
	GnomenuParser* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNOMENU_PARSER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




