
#include <tests/testman.h>




struct _TestManPrivate {
	char* _uri;
};

#define TEST_MAN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TEST_MAN, TestManPrivate))
enum  {
	TEST_MAN_DUMMY_PROPERTY,
	TEST_MAN_URI
};
static gboolean __lambda0 (GtkWindow* window, TestMan* self);
static gboolean ___lambda0_gtk_widget_delete_event (GtkWindow* _sender, const GdkEvent* event, gpointer self);
static void test_man_set_uri (TestMan* self, const char* value);
static gpointer test_man_parent_class = NULL;
static void test_man_finalize (GObject* obj);



TestMan* test_man_construct (GType object_type, const char* uri) {
	GParameter * __params;
	GParameter * __params_it;
	TestMan * self;
	g_return_val_if_fail (uri != NULL, NULL);
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
	__params_it->name = "uri";
	g_value_init (&__params_it->value, G_TYPE_STRING);
	g_value_set_string (&__params_it->value, uri);
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


TestMan* test_man_new (const char* uri) {
	return test_man_construct (TYPE_TEST_MAN, uri);
}


void test_man_add (TestMan* self, const char* name, GDataTestFunc func, void* func_target) {
	char* _tmp1;
	char* _tmp0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp1 = NULL;
	_tmp0 = NULL;
	g_test_add_data_func (_tmp1 = g_strconcat (_tmp0 = g_strconcat (self->priv->_uri, "/", NULL), name, NULL), func_target, func);
	_tmp1 = (g_free (_tmp1), NULL);
	_tmp0 = (g_free (_tmp0), NULL);
}


void test_man_run (TestMan* self) {
	GtkWindow* _tmp0;
	g_return_if_fail (self != NULL);
	test_man_create_test_window (self);
	g_test_run ();
	gtk_object_destroy ((GtkObject*) self->window);
	_tmp0 = NULL;
	self->window = (_tmp0 = NULL, (self->window == NULL) ? NULL : (self->window = (g_object_unref (self->window), NULL)), _tmp0);
}


static gboolean __lambda0 (GtkWindow* window, TestMan* self) {
	g_return_val_if_fail (window != NULL, FALSE);
	gtk_widget_hide_on_delete ((GtkWidget*) window);
	gtk_main_quit ();
	gtk_widget_unrealize ((GtkWidget*) window);
	return TRUE;
}


static gboolean ___lambda0_gtk_widget_delete_event (GtkWindow* _sender, const GdkEvent* event, gpointer self) {
	return __lambda0 (_sender, self);
}


void test_man_create_test_window (TestMan* self) {
	GtkWindow* _tmp0;
	g_return_if_fail (self != NULL);
	_tmp0 = NULL;
	self->window = (_tmp0 = g_object_ref_sink ((GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL)), (self->window == NULL) ? NULL : (self->window = (g_object_unref (self->window), NULL)), _tmp0);
	g_message ("testman.vala:20: window created");
	g_signal_connect ((GtkWidget*) self->window, "delete-event", (GCallback) ___lambda0_gtk_widget_delete_event, self);
}


const char* test_man_get_uri (TestMan* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_uri;
}


static void test_man_set_uri (TestMan* self, const char* value) {
	char* _tmp2;
	const char* _tmp1;
	g_return_if_fail (self != NULL);
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_uri = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_strdup (_tmp1)), self->priv->_uri = (g_free (self->priv->_uri), NULL), _tmp2);
	g_object_notify ((GObject *) self, "uri");
}


static void test_man_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TestMan * self;
	gpointer boxed;
	self = TEST_MAN (object);
	switch (property_id) {
		case TEST_MAN_URI:
		g_value_set_string (value, test_man_get_uri (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void test_man_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TestMan * self;
	self = TEST_MAN (object);
	switch (property_id) {
		case TEST_MAN_URI:
		test_man_set_uri (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void test_man_class_init (TestManClass * klass) {
	test_man_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TestManPrivate));
	G_OBJECT_CLASS (klass)->get_property = test_man_get_property;
	G_OBJECT_CLASS (klass)->set_property = test_man_set_property;
	G_OBJECT_CLASS (klass)->finalize = test_man_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEST_MAN_URI, g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void test_man_instance_init (TestMan * self) {
	self->priv = TEST_MAN_GET_PRIVATE (self);
}


static void test_man_finalize (GObject* obj) {
	TestMan * self;
	self = TEST_MAN (obj);
	self->priv->_uri = (g_free (self->priv->_uri), NULL);
	(self->window == NULL) ? NULL : (self->window = (g_object_unref (self->window), NULL));
	G_OBJECT_CLASS (test_man_parent_class)->finalize (obj);
}


GType test_man_get_type (void) {
	static GType test_man_type_id = 0;
	if (test_man_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (TestManClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) test_man_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TestMan), 0, (GInstanceInitFunc) test_man_instance_init, NULL };
		test_man_type_id = g_type_register_static (G_TYPE_OBJECT, "TestMan", &g_define_type_info, 0);
	}
	return test_man_type_id;
}




