
#include "image-to-vala.h"
#include <stdio.h>




char** filenames = NULL;
char** names = NULL;
char* namespace = NULL;
char* class = NULL;



char* pixbuf_encode_b64 (GdkPixbuf* pixbuf) {
	GdkPixdata pixdata = {(guint32) 0};
	guchar* _tmp1;
	gint _tmp0;
	g_return_val_if_fail (pixbuf != NULL, NULL);
	gdk_pixdata_from_pixbuf (&pixdata, pixbuf, TRUE);
	_tmp1 = NULL;
	return (_tmp1 = gdk_pixdata_serialize (&pixdata, &_tmp0), g_base64_encode (_tmp1, _tmp0));
}


gint _main (char** args, int args_length1) {
	GError * inner_error;
	GOptionContext* context;
	gint i;
	gint _tmp3;
	inner_error = NULL;
	context = g_option_context_new (" - Convert image to gnomenu string");
	g_option_context_add_main_entries (context, options, NULL);
	g_option_context_parse (context, &args_length1, &args, &inner_error);
	if (inner_error != NULL) {
		(context == NULL) ? NULL : (context = (g_option_context_free (context), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return 0;
	}
	i = 0;
	if (namespace != NULL) {
		fprintf (stdout, "namespace %s {\n", namespace);
	}
	if (class != NULL) {
		fprintf (stdout, "\tclass %s {\n", class);
	}
	for (i = 0; TRUE; i++) {
		gboolean _tmp0;
		const char* _tmp1;
		char* filename;
		const char* _tmp2;
		char* name;
		_tmp0 = FALSE;
		if (filenames != NULL) {
			_tmp0 = filenames[i] != NULL;
		} else {
			_tmp0 = FALSE;
		}
		if (!_tmp0) {
			break;
		}
		_tmp1 = NULL;
		filename = (_tmp1 = filenames[i], (_tmp1 == NULL) ? NULL : g_strdup (_tmp1));
		_tmp2 = NULL;
		name = (_tmp2 = names[i], (_tmp2 == NULL) ? NULL : g_strdup (_tmp2));
		{
			GdkPixbuf* pixbuf;
			char* str;
			pixbuf = gdk_pixbuf_new_from_file (filename, &inner_error);
			if (inner_error != NULL) {
				goto __catch0_g_error;
				goto __finally0;
			}
			str = pixbuf_encode_b64 (pixbuf);
			if (class != NULL) {
				fprintf (stdout, "\t\tpublic static ");
			} else {
				fprintf (stdout, "\tpublic ");
			}
			fprintf (stdout, "const string %s = \"\"\"pixbuf:%s\"\"\";\n", names[i], str);
			(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
			str = (g_free (str), NULL);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError * e;
			e = inner_error;
			inner_error = NULL;
			{
				g_warning ("image-to-vala.vala:48: %s", e->message);
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally0:
		if (inner_error != NULL) {
			filename = (g_free (filename), NULL);
			name = (g_free (name), NULL);
			(context == NULL) ? NULL : (context = (g_option_context_free (context), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
			g_clear_error (&inner_error);
			return 0;
		}
		filename = (g_free (filename), NULL);
		name = (g_free (name), NULL);
	}
	if (class != NULL) {
		fprintf (stdout, "\t}\n");
	}
	if (namespace != NULL) {
		fprintf (stdout, "}\n");
	}
	return (_tmp3 = 0, (context == NULL) ? NULL : (context = (g_option_context_free (context), NULL)), _tmp3);
}


int main (int argc, char ** argv) {
	g_type_init ();
	return _main (argv, argc);
}




